<!-- README.md is generated from README.Rmd. Please edit that file -->

# readxl <a href="https://readxl.tidyverse.org"><img src="man/figures/logo.png" align="right" height="138" /></a>

<!-- badges: start -->

[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/readxl)](https://cran.r-project.org/package=readxl)
[![R-CMD-check](https://github.com/tidyverse/readxl/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/tidyverse/readxl/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/tidyverse/readxl/graph/badge.svg)](https://app.codecov.io/gh/tidyverse/readxl)
[![lifecycle](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html)
<!-- badges: end -->

## Overview

The readxl package makes it easy to get data out of Excel and into R.
Compared to many of the existing packages (e.g. gdata, xlsx,
xlsReadWrite) readxl has no external dependencies, so it’s easy to
install and use on all operating systems. It is designed to work with
*tabular* data.

readxl supports both the legacy `.xls` format and the modern xml-based
`.xlsx` format. The [libxls](https://github.com/libxls/libxls) C library
is used to support `.xls`, which abstracts away many of the complexities
of the underlying binary format. To parse `.xlsx`, we use the
[RapidXML](https://rapidxml.sourceforge.net/) C++ library.

## Installation

The easiest way to install the latest released version from CRAN is to
install the whole tidyverse.

``` r
install.packages("tidyverse")
```

NOTE: you will still need to load readxl explicitly, because it is not a
core tidyverse package loaded via `library(tidyverse)`.

Alternatively, install just readxl from CRAN:

``` r
install.packages("readxl")
```

Or install the development version from GitHub:

``` r
#install.packages("pak")
pak::pak("tidyverse/readxl")
```

## Cheatsheet

You can see how to read data with readxl in the **data import
cheatsheet**, which also covers similar functionality in the related
packages readr and googlesheets4.

<a href="https://github.com/rstudio/cheatsheets/blob/main/data-import.pdf"><img src="https://raw.githubusercontent.com/rstudio/cheatsheets/main/pngs/thumbnails/data-import-cheatsheet-thumbs.png" width="630" height="252"/></a>

## Usage

``` r
library(readxl)
```

readxl includes several example files, which we use throughout the
documentation. Use the helper `readxl_example()` with no arguments to
list them or call it with an example filename to get the path.

``` r
readxl_example()
#>  [1] "clippy.xls"    "clippy.xlsx"   "datasets.xls"  "datasets.xlsx"
#>  [5] "deaths.xls"    "deaths.xlsx"   "geometry.xls"  "geometry.xlsx"
#>  [9] "type-me.xls"   "type-me.xlsx"
readxl_example("clippy.xls")
#> [1] "/private/tmp/RtmpkPT2Y6/temp_libpathfed65a294c90/readxl/extdata/clippy.xls"
```

`read_excel()` reads both xls and xlsx files and detects the format from
the extension.

``` r
xlsx_example <- readxl_example("datasets.xlsx")
read_excel(xlsx_example)
#> # A tibble: 32 × 11
#>     mpg   cyl  disp    hp  drat    wt  qsec    vs    am  gear  carb
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1  21       6   160   110  3.9   2.62  16.5     0     1     4     4
#> 2  21       6   160   110  3.9   2.88  17.0     0     1     4     4
#> 3  22.8     4   108    93  3.85  2.32  18.6     1     1     4     1
#> # ℹ 29 more rows

xls_example <- readxl_example("datasets.xls")
read_excel(xls_example)
#> # A tibble: 32 × 11
#>     mpg   cyl  disp    hp  drat    wt  qsec    vs    am  gear  carb
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1  21       6   160   110  3.9   2.62  16.5     0     1     4     4
#> 2  21       6   160   110  3.9   2.88  17.0     0     1     4     4
#> 3  22.8     4   108    93  3.85  2.32  18.6     1     1     4     1
#> # ℹ 29 more rows
```

List the sheet names with `excel_sheets()`.

``` r
excel_sheets(xlsx_example)
#> [1] "mtcars"   "chickwts" "quakes"
```

Specify a worksheet by name or number.

``` r
read_excel(xlsx_example, sheet = "chickwts")
#> # A tibble: 71 × 2
#>   weight feed     
#>    <dbl> <chr>    
#> 1    179 horsebean
#> 2    160 horsebean
#> 3    136 horsebean
#> # ℹ 68 more rows
read_excel(xls_example, sheet = 3)
#> # A tibble: 1,000 × 5
#>     lat  long depth   mag stations
#>   <dbl> <dbl> <dbl> <dbl>    <dbl>
#> 1 -20.4  182.   562   4.8       41
#> 2 -20.6  181.   650   4.2       15
#> 3 -26    184.    42   5.4       43
#> # ℹ 997 more rows
```

There are various ways to control which cells are read. You can even
specify the sheet here, if providing an Excel-style cell range.

``` r
read_excel(xlsx_example, n_max = 3)
#> # A tibble: 3 × 11
#>     mpg   cyl  disp    hp  drat    wt  qsec    vs    am  gear  carb
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1  21       6   160   110  3.9   2.62  16.5     0     1     4     4
#> 2  21       6   160   110  3.9   2.88  17.0     0     1     4     4
#> 3  22.8     4   108    93  3.85  2.32  18.6     1     1     4     1
read_excel(xlsx_example, range = "C1:E4")
#> # A tibble: 3 × 3
#>    disp    hp  drat
#>   <dbl> <dbl> <dbl>
#> 1   160   110  3.9 
#> 2   160   110  3.9 
#> 3   108    93  3.85
read_excel(xlsx_example, range = cell_rows(1:4))
#> # A tibble: 3 × 11
#>     mpg   cyl  disp    hp  drat    wt  qsec    vs    am  gear  carb
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1  21       6   160   110  3.9   2.62  16.5     0     1     4     4
#> 2  21       6   160   110  3.9   2.88  17.0     0     1     4     4
#> 3  22.8     4   108    93  3.85  2.32  18.6     1     1     4     1
read_excel(xlsx_example, range = cell_cols("B:D"))
#> # A tibble: 32 × 3
#>     cyl  disp    hp
#>   <dbl> <dbl> <dbl>
#> 1     6   160   110
#> 2     6   160   110
#> 3     4   108    93
#> # ℹ 29 more rows
read_excel(xlsx_example, range = "mtcars!B1:D5")
#> # A tibble: 4 × 3
#>     cyl  disp    hp
#>   <dbl> <dbl> <dbl>
#> 1     6   160   110
#> 2     6   160   110
#> 3     4   108    93
#> # ℹ 1 more row
```

If `NA`s are represented by something other than blank cells, set the
`na` argument.

``` r
read_excel(xlsx_example, na = "0")
#> # A tibble: 32 × 11
#>     mpg   cyl  disp    hp  drat    wt  qsec    vs    am  gear  carb
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1  21       6   160   110  3.9   2.62  16.5    NA     1     4     4
#> 2  21       6   160   110  3.9   2.88  17.0    NA     1     4     4
#> 3  22.8     4   108    93  3.85  2.32  18.6     1     1     4     1
#> # ℹ 29 more rows
```

If you are new to the tidyverse conventions for data import, you may
want to consult the [data import
chapter](https://r4ds.had.co.nz/data-import.html) in R for Data Science.
readxl will become increasingly consistent with other packages, such as
[readr](https://readr.tidyverse.org/).

## Articles

Broad topics are explained in [these
articles](https://readxl.tidyverse.org/articles/index.html):

- [Cell and Column
  Types](https://readxl.tidyverse.org/articles/cell-and-column-types.html)
- [Sheet
  Geometry](https://readxl.tidyverse.org/articles/sheet-geometry.html):
  how to specify which cells to read
- [readxl
  Workflows](https://readxl.tidyverse.org/articles/articles/readxl-workflows.html):
  Iterating over multiple tabs or worksheets, stashing a csv snapshot

We also have some focused articles that address specific aggravations
presented by the world’s spreadsheets:

- [Column
  Names](https://readxl.tidyverse.org/articles/articles/column-names.html)
- [Multiple Header
  Rows](https://readxl.tidyverse.org/articles/articles/multiple-header-rows.html)

## Features

- No external dependency on, e.g., Java or Perl.

- Re-encodes non-ASCII characters to UTF-8.

- Loads datetimes into POSIXct columns. Both Windows (1900) and
  Mac (1904) date specifications are processed correctly.

- Discovers the minimal data rectangle and returns that, by default.
  User can exert more control with `range`, `skip`, and `n_max`.

- Column names and types are determined from the data in the sheet, by
  default. User can also supply via `col_names` and `col_types` and
  control name repair via `.name_repair`.

- Returns a
  [tibble](https://tibble.tidyverse.org/reference/tibble.html), i.e. a
  data frame with an additional `tbl_df` class. Among other things, this
  provide nicer printing.

## Other relevant packages

Here are some other packages with functionality that is complementary to
readxl and that also avoid a Java dependency.

**Writing Excel files**: The example files `datasets.xlsx` and
`datasets.xls` were created with the help of
[openxlsx](https://CRAN.R-project.org/package=openxlsx) (and Excel).
openxlsx provides “a high level interface to writing, styling and
editing worksheets”.

``` r
l <- list(mtcars = mtcars, chickwts = chickwts, quakes = quakes)
openxlsx::write.xlsx(l, file = "inst/extdata/datasets.xlsx")
```

[writexl](https://cran.r-project.org/package=writexl) is a new option in
this space, first released on CRAN in August 2017. It’s a portable and
lightweight way to export a data frame to xlsx, based on
[libxlsxwriter](https://github.com/jmcnamara/libxlsxwriter). It is much
more minimalistic than openxlsx, but on simple examples, appears to be
about twice as fast and to write smaller files.

**Non-tabular data and formatting**:
[tidyxl](https://cran.r-project.org/package=tidyxl) is focused on
importing awkward and non-tabular data from Excel. It also “exposes cell
content, position and formatting in a tidy structure for further
manipulation”.

#' List all sheets in an excel spreadsheet
#'
#' The list of sheet names is especially useful when you want to iterate over
#' all of the sheets in a workbook. The [readxl Workflows article](https://readxl.tidyverse.org/articles/readxl-workflows.html)
#' provides several worked examples of this, showing how to combine readxl with
#' other packages in the tidyverse, such as purrr, or with base R functions like
#' [lapply()].
#'
#' @inheritParams read_excel
#' @export
#' @examples
#' excel_sheets(readxl_example("datasets.xlsx"))
#' excel_sheets(readxl_example("datasets.xls"))
#'
#' # To load all sheets in a workbook, use lapply()
#' path <- readxl_example("datasets.xls")
#' lapply(excel_sheets(path), read_excel, path = path)
excel_sheets <- function(path) {
  path <- check_file(path)
  format <- check_format(path)

  switch(format, xls = xls_sheets(path), xlsx = xlsx_sheets(path))
}

test_that("informative error when requesting non-existent sheet by name", {
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = "tulip")
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), range = "tulip!A1:A1")
  )
})

test_that("informative error when requesting non-existent sheet by position", {
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = 2)
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xls.xls"), sheet = 2)
  )
})

test_that("invalid sheet values caught", {
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = 0)
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = rep(1L, 2))
  )
})

test_that("sheet can be parsed out of range", {
  direct <-
    read_excel(
      test_sheet("iris-excel-xlsx.xlsx"),
      sheet = "iris",
      range = "A1:A1"
    )
  indirect <-
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), range = "iris!A1:A1")
  expect_identical(direct, indirect)
})

test_that("double specification of sheet generates message and range wins", {
  expect_snapshot(
    double <-
      read_excel(
        test_sheet("sheet-xml-lookup.xlsx"),
        sheet = "Asia",
        range = "Oceania!A1:A1"
      )
  )
  ref <- read_excel(
    test_sheet("sheet-xml-lookup.xlsx"),
    range = "Oceania!A1:A1"
  )
  expect_identical(double, ref)
})

test_that("sheet data xml target is explicitly looked up (#104, #80)", {
  xlsx <- test_sheet("sheet-xml-lookup.xlsx")
  countries <- excel_sheets(xlsx)
  ## what's important about this workbook?
  ## xml target for worksheet i is NOT sheeti.xml
  ##       name    Id                   Target
  ##      <chr> <chr>                    <chr>
  ## 1   Africa  rId3 xl/worksheets/sheet4.xml
  ## 2 Americas  rId4 xl/worksheets/sheet3.xml
  ## 3     Asia  rId5 xl/worksheets/sheet5.xml
  ## 4   Europe  rId6 xl/worksheets/sheet1.xml
  ## 5  Oceania  rId7 xl/worksheets/sheet2.xml
  ## tests that we find xml target like so: (name ->) i -> Id -> Target
  ## embedded-chartsheet.xlsx has an embedded chartsheet but I see no
  ## current reason to explicitly test (#116, #200)
  for (cty in countries) {
    df <- read_excel(xlsx, sheet = cty)
    expect_identical(df$continent[1], cty)
  }
  for (i in seq_along(countries)) {
    df <- read_excel(xlsx, sheet = i)
    expect_identical(df$continent[1], countries[i])
  }
})

#' Determine file format
#'
#' @description Determine if files are xls or xlsx (or from the xlsx family).
#'
#' @description `excel_format(guess = TRUE)` is used by `read_excel()` to
#'   determine format. It draws on logic from two lower level functions:
#'   * `format_from_ext()` attempts to determine format from the file extension.
#'   * `format_from_signature()` consults the [file
#'   signature](https://en.wikipedia.org/wiki/List_of_file_signatures) or "magic
#'   number".
#'
#' @description File extensions associated with xlsx vs. xls:
#'   * xlsx: `.xlsx`, `.xlsm`, `.xltx`, `.xltm`
#'   * xls: `.xls`
#'
#' @description File signatures (in hexadecimal) for xlsx vs xls:
#'   * xlsx: First 4 bytes are `50 4B 03 04`
#'   * xls: First 8 bytes are `D0 CF 11 E0 A1 B1 1A E1`
#'
#' @inheritParams read_excel
#' @param guess Logical. If the file extension is absent or not recognized, this
#'   controls whether we attempt to guess format based on the file signature or
#'   "magic number".
#'
#' @return Character vector with values `"xlsx"`, `"xls"`, or `NA`.
#' @export
#'
#' @examples
#' files <- c(
#'   "a.xlsx",
#'   "b.xls",
#'   "c.png",
#'   file.path(R.home("doc"), "html", "logo.jpg"),
#'   readxl_example("clippy.xlsx"),
#'   readxl_example("deaths.xls")
#' )
#' excel_format(files)
excel_format <- function(path, guess = TRUE) {
  format <- format_from_ext(path)
  if (!isTRUE(guess)) {
    return(format)
  }
  guess_me <- is.na(format) & file.exists(path)
  format[guess_me] <- format_from_signature(path[guess_me])
  format
}

#' @rdname excel_format
#' @export
format_from_ext <- function(path) {
  ext <- tolower(tools::file_ext(path))

  formats <- c(
    xls = "xls",
    xlsx = "xlsx",
    xlsm = "xlsx",
    xltx = "xlsx",
    xltm = "xlsx"
  )
  unname(formats[ext])
}

#' @rdname excel_format
#' @export
format_from_signature <- function(path) {
  signature <- lapply(path, first_8_bytes)
  vapply(signature, sig_to_fmt, "xlsx?")
}

first_8_bytes <- function(x) readBin(x, n = 8, what = "raw")

sig_to_fmt <- function(x) {
  ## https://en.wikipedia.org/wiki/List_of_file_signatures
  xlsx_sig <- as.raw(c(
    "0x50",
    "0x4B",
    "0x03",
    "0x04"
  ))
  xls_sig <- as.raw(c(
    "0xD0",
    "0xCF",
    "0x11",
    "0xE0",
    "0xA1",
    "0xB1",
    "0x1A",
    "0xE1"
  ))

  if (identical(x[1:4], xlsx_sig)) {
    "xlsx"
  } else if (identical(x, xls_sig)) {
    "xls"
  } else {
    NA_character_
  }
}

check_format <- function(path) {
  format <- excel_format(path)
  if (is.na(format)) {
    stop("Can't establish that the input is either xls or xlsx.", call. = FALSE)
  }
  format
}

#' Determine whether to show progress spinner
#'
#' @description By default, readxl displays a progress spinner **unless**
#'   one of the following is `TRUE`:
#' * The spinner is explicitly disabled by setting
#'   `options(readxl.show_progress = FALSE)`.
#' * The code is run in a non-interactive session (`interactive()` is `FALSE`).
#' * The code is run by knitr / rmarkdown.
#' * The code is run in an RStudio notebook chunk.
#' readxl uses the [progress
#' package](https://cran.r-project.org/package=progress) under-the-hood and
#' therefore is also sensitive to any options that it consults.
#' @export
readxl_progress <- function() {
  ## based on readr:::show_progress()
  isTRUE(getOption("readxl.show_progress", default = TRUE)) &&
    interactive() &&
    !isTRUE(getOption("knitr.in.progress")) &&
    !isTRUE(getOption("rstudio.notebook.executing"))
}

check_file <- function(path) {
  if (!is_string(path)) {
    stop("`path` must be a string", call. = FALSE)
  }

  if (!file.exists(path)) {
    stop("`path` does not exist: ", sQuote(path), call. = FALSE)
  }
  # We already know the file exists, so we can use `mustWork = FALSE`.
  # Why would we want to do that?
  # https://github.com/tidyverse/readxl/issues/730
  # There are reports of a spurious "Access is denied" warning when the
  # file lives on a Windows network share whose parent directory is not
  # accessible to the user, even though the file itself is readable.
  normalizePath(path, mustWork = FALSE)
}

is_integerish <- function(x) {
  floor(x) == x
}

is_string <- function(x) {
  length(x) == 1 && is.character(x)
}

#' Specify cells for reading
#'
#' The `range` argument of [read_excel()] provides many ways to limit the read
#' to a specific rectangle of cells. The simplest usage is to provide an
#' Excel-like cell range, such as `range = "D12:F15"` or
#' `range ="R1C12:R6C15"`. The cell rectangle can be specified in various other ways,
#' using helper functions. You can find more examples at the
#'  [sheet geometry](https://readxl.tidyverse.org/articles/sheet-geometry.html#range)
#'  vignette. In all cases, cell range processing is handled by the
#' [cellranger][cellranger::cellranger] package, where you can find full documentation for
#' the functions used in the examples below.
#'
#' @examples
#' path <- readxl_example("geometry.xls")
#' ## Rows 1 and 2 are empty (as are rows 7 and higher)
#' ## Column 1 aka "A" is empty (as are columns 5 of "E" and higher)
#'
#' # By default, the populated data cells are "shrink-wrapped" into a
#' # minimal data frame
#' read_excel(path)
#'
#' # Specific rectangle that is subset of populated cells, possibly improper
#' read_excel(path, range = "B3:D6")
#' read_excel(path, range = "C3:D5")
#'
#' # Specific rectangle that forces inclusion of unpopulated cells
#' read_excel(path, range = "A3:D5")
#' read_excel(path, range = "A4:E5")
#' read_excel(path, range = "C5:E7")
#'
#' # Anchor a rectangle of specified size at a particular cell
#' read_excel(path, range = anchored("C4", dim = c(3, 2)), col_names = FALSE)
#'
#' # Specify only the rows
#' read_excel(path, range = cell_rows(3:5))
#' ## is equivalent to
#' read_excel(path, range = cell_rows(c(3, 5)))
#'
#' # Specify only the columns by column number or letter
#' read_excel(path, range = cell_cols("C:D"))
#' read_excel(path, range = cell_cols(2))
#'
#' # Specify exactly one row or column bound
#' read_excel(path, range = cell_rows(c(5, NA)))
#' read_excel(path, range = cell_rows(c(NA, 4)))
#' read_excel(path, range = cell_cols(c("C", NA)))
#' read_excel(path, range = cell_cols(c(NA, 2)))
#'
#' # General open rectangles
#' # upper left = C4, everything else unspecified
#' read_excel(path, range = cell_limits(c(4, 3), c(NA, NA)))
#' # upper right = D4, everything else unspecified
#' read_excel(path, range = cell_limits(c(4, NA), c(NA, 4)))
#'
#' @seealso The [cellranger][cellranger::cellranger] package has full documentation on cell
#'   specification and offers additional functions for manipulating "A1:D10"
#'   style spreadsheet ranges. Here are the most relevant:
#'   \itemize{
#'     \item [cellranger::cell_limits()]
#'     \item [cellranger::cell_rows()]
#'     \item [cellranger::cell_cols()]
#'     \item [cellranger::anchored()]
#'   }
#' @name cell-specification
NULL

#' @importFrom cellranger cell_limits
#' @name cell_limits
#' @export
#' @rdname cell-specification
NULL

#' @importFrom cellranger cell_rows
#' @name cell_rows
#' @export
#' @rdname cell-specification
NULL

#' @importFrom cellranger cell_cols
#' @name cell_cols
#' @export
#' @rdname cell-specification
NULL

#' @importFrom cellranger anchored
#' @name anchored
#' @export
#' @rdname cell-specification
NULL

#' @useDynLib readxl, .registration = TRUE
NULL

#' Read xls and xlsx files
#'
#' @param path Path to the xls/xlsx file.
#' @param sheet Sheet to read. Either a string (the name of a sheet), or an
#'   integer (the position of the sheet). Ignored if the sheet is specified via
#'   `range`. If neither argument specifies the sheet, defaults to the first
#'   sheet.
#' @param range A cell range to read from, as described in [cell-specification].
#'   Includes typical Excel ranges like "B3:D87", possibly including the sheet
#'   name like "Budget!B2:G14", and more. Interpreted strictly, even if the
#'   range forces the inclusion of leading or trailing empty rows or columns.
#'   Takes precedence over `skip`, `n_max` and `sheet`.
#' @param col_names `TRUE` to use the first row as column names, `FALSE` to get
#'   default names, or a character vector giving a name for each column. If user
#'   provides `col_types` as a vector, `col_names` can have one entry per
#'   column, i.e. have the same length as `col_types`, or one entry per
#'   unskipped column.
#' @param col_types Either `NULL` to guess all from the spreadsheet or a
#'   character vector containing one entry per column from these options:
#'   "skip", "guess", "logical", "numeric", "date", "text" or "list". If exactly
#'   one `col_type` is specified, it will be recycled. The content of a cell in
#'   a skipped column is never read and that column will not appear in the data
#'   frame output. A list cell loads a column as a list of length 1 vectors,
#'   which are typed using the type guessing logic from `col_types = NULL`, but
#'   on a cell-by-cell basis.
#' @param na Character vector of strings to interpret as missing values. By
#'   default, readxl treats blank cells as missing data.
#' @param trim_ws Should leading and trailing whitespace be trimmed?
#' @param skip Minimum number of rows to skip before reading anything, be it
#'   column names or data. Leading empty rows are automatically skipped, so this
#'   is a lower bound. Ignored if `range` is given.
#' @param n_max Maximum number of data rows to read. Trailing empty rows are
#'   automatically skipped, so this is an upper bound on the number of rows in
#'   the returned tibble. Ignored if `range` is given.
#' @param guess_max Maximum number of data rows to use for guessing column
#'   types.
#' @param progress Display a progress spinner? By default, the spinner appears
#'   only in an interactive session, outside the context of knitting a document,
#'   and when the call is likely to run for several seconds or more. See
#'   [readxl_progress()] for more details.
#' @param .name_repair Handling of column names. Passed along to
#'   [tibble::as_tibble()]. readxl's default is `.name_repair = "unique", which
#'   ensures column names are not empty and are unique.
#' @return A [tibble][tibble::tibble-package]
#' @seealso [cell-specification] for more details on targetting cells with the
#'   `range` argument
#' @export
#' @examples
#' datasets <- readxl_example("datasets.xlsx")
#' read_excel(datasets)
#'
#' # Specify sheet either by position or by name
#' read_excel(datasets, 2)
#' read_excel(datasets, "mtcars")
#'
#' # Skip rows and use default column names
#' read_excel(datasets, skip = 10, col_names = FALSE)
#'
#' # Recycle a single column type
#' read_excel(datasets, col_types = "text")
#'
#' # Specify some col_types and guess others
#' read_excel(
#'   readxl_example("deaths.xlsx"),
#'   skip = 4, n_max = 10, col_names = TRUE,
#'   col_types = c("text", "text", "guess", "guess", "guess", "guess")
#' )
#'
#' # Accomodate a column with disparate types via col_type = "list"
#' df <- read_excel(readxl_example("clippy.xlsx"), col_types = c("text", "list"))
#' df
#' df$value
#' sapply(df$value, class)
#'
#' # Limit the number of data rows read
#' read_excel(datasets, n_max = 3)
#'
#' # Read from an Excel range using A1 or R1C1 notation
#' read_excel(datasets, range = "C1:E7")
#' read_excel(datasets, range = "R1C2:R2C5")
#'
#' # Specify the sheet as part of the range
#' read_excel(datasets, range = "mtcars!B1:D5")
#'
#' # Read only specific rows or columns
#' read_excel(datasets, range = cell_rows(102:151), col_names = FALSE)
#' read_excel(datasets, range = cell_cols("B:D"))
#'
#' # Get a preview of column names
#' names(read_excel(readxl_example("datasets.xlsx"), n_max = 0))
#'
#' # exploit full .name_repair flexibility from tibble
#'
#' # "universal" names are unique and syntactic
#' read_excel(
#'   readxl_example("deaths.xlsx"),
#'   range = "arts!A5:F15",
#'   .name_repair = "universal"
#' )
#'
#' # specify name repair as a built-in function
#' read_excel(readxl_example("clippy.xlsx"), .name_repair = toupper)
#'
#' # specify name repair as a custom function
#' my_custom_name_repair <- function(nms) tolower(gsub("[.]", "_", nms))
#' read_excel(
#'   readxl_example("datasets.xlsx"),
#'   .name_repair = my_custom_name_repair
#' )
#'
#' # specify name repair as an anonymous function
#' read_excel(
#'   readxl_example("datasets.xlsx"),
#'   sheet = "chickwts",
#'   .name_repair = ~ substr(.x, start = 1, stop = 3)
#' )
read_excel <- function(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
) {
  path <- check_file(path)
  format <- check_format(path)
  read_excel_(
    path = path,
    sheet = sheet,
    range = range,
    col_names = col_names,
    col_types = col_types,
    na = na,
    trim_ws = trim_ws,
    skip = skip,
    n_max = n_max,
    guess_max = guess_max,
    progress = progress,
    .name_repair = .name_repair,
    format = format
  )
}

#' `read_excel()` calls [excel_format()] to determine if `path` is xls or xlsx,
#' based on the file extension and the file itself, in that order. Use
#' `read_xls()` and `read_xlsx()` directly if you know better and want to
#' prevent such guessing.
#' @rdname read_excel
#' @export
read_xls <- function(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
) {
  path <- check_file(path)
  read_excel_(
    path = path,
    sheet = sheet,
    range = range,
    col_names = col_names,
    col_types = col_types,
    na = na,
    trim_ws = trim_ws,
    skip = skip,
    n_max = n_max,
    guess_max = guess_max,
    progress = progress,
    .name_repair = .name_repair,
    format = "xls"
  )
}

#' @rdname read_excel
#' @export
read_xlsx <- function(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
) {
  path <- check_file(path)
  read_excel_(
    path = path,
    sheet = sheet,
    range = range,
    col_names = col_names,
    col_types = col_types,
    na = na,
    trim_ws = trim_ws,
    skip = skip,
    n_max = n_max,
    guess_max = guess_max,
    progress = progress,
    .name_repair = .name_repair,
    format = "xlsx"
  )
}

read_excel_ <- function(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = NULL,
  format
) {
  if (format == "xls") {
    sheets_fun <- xls_sheets
    read_fun <- read_xls_
  } else {
    sheets_fun <- xlsx_sheets
    read_fun <- read_xlsx_
  }
  sheet <- standardise_sheet(sheet, range, sheets_fun(path))
  shim <- !is.null(range)
  limits <- standardise_limits(
    range,
    skip,
    n_max,
    has_col_names = isTRUE(col_names)
  )
  col_types <- check_col_types(col_types)
  guess_max <- check_guess_max(guess_max)
  trim_ws <- check_bool(trim_ws, "trim_ws")
  progress <- check_bool(progress, "progress")
  set_readxl_names(
    read_fun(
      path = path,
      sheet_i = sheet,
      limits = limits,
      shim = shim,
      col_names = col_names,
      col_types = col_types,
      na = na,
      trim_ws = trim_ws,
      guess_max = guess_max,
      progress = progress
    ),
    .name_repair = .name_repair
  )
}

# Helper functions -------------------------------------------------------------

## return a zero-indexed sheet number
standardise_sheet <- function(sheet, range, sheet_names) {
  range_sheet <- cellranger::as.cell_limits(range)[["sheet"]]
  if (!is.null(range_sheet) && !is.na(range_sheet)) {
    if (!is.null(sheet)) {
      message(
        "Two values given for `sheet`. ",
        "Using the `sheet` found in `range`:\n",
        range_sheet
      )
    }
    sheet <- range_sheet
  }

  if (is.null(sheet)) {
    sheet <- 1L
  }

  if (length(sheet) != 1) {
    stop("`sheet` must have length 1", call. = FALSE)
  }

  if (is.numeric(sheet)) {
    if (sheet < 1) {
      stop("`sheet` must be positive", call. = FALSE)
    }
    floor(sheet) - 1L
  } else if (is.character(sheet)) {
    if (!(sheet %in% sheet_names)) {
      stop("Sheet '", sheet, "' not found", call. = FALSE)
    }
    match(sheet, sheet_names) - 1L
  } else {
    stop("`sheet` must be either an integer or a string.", call. = FALSE)
  }
}

## return a zero-indexed vector describing the corners of a cell rectangle:
## min_row, max_row, min_col, max_col
## NA becomes -1 and means "unspecified", by convention
## if both min and max are -1, for rows or cols, means "read them all"
## min_row = -2 is a special flag meaning "read no rows"
standardise_limits <- function(range, skip, n_max, has_col_names) {
  if (is.null(range)) {
    skip <- check_non_negative_integer(skip, "skip")
    n_max <- check_non_negative_integer(n_max, "n_max")
    n_read <- if (has_col_names) n_max + 1 else n_max
    limits <- c(
      min_row = if (n_read > 0) skip else -2,
      max_row = if (n_read == Inf || n_read == 0) NA else skip + n_read - 1,
      min_col = NA,
      max_col = NA
    )
  } else {
    limits <- cellranger::as.cell_limits(range)
    limits <- c(
      min_row = limits[["ul"]][1] - 1,
      max_row = limits[["lr"]][1] - 1,
      min_col = limits[["ul"]][2] - 1,
      max_col = limits[["lr"]][2] - 1
    )
  }
  limits[is.na(limits)] <- -1
  names <- names(limits)
  limits <- as.integer(limits)
  names(limits) <- names
  limits
}

check_col_types <- function(col_types) {
  if (is.null(col_types)) {
    return("guess")
  }
  stopifnot(is.character(col_types), length(col_types) > 0, !anyNA(col_types))

  blank <- col_types == "blank"
  if (any(blank)) {
    message("`col_type = \"blank\"` deprecated. Use \"skip\" instead.")
    col_types[blank] <- "skip"
  }

  accepted_types <-
    c("skip", "guess", "logical", "numeric", "date", "text", "list")
  ok <- col_types %in% accepted_types
  if (any(!ok)) {
    info <- paste(
      paste0("'", col_types[!ok], "' [", seq_along(col_types)[!ok], "]"),
      collapse = ", "
    )
    stop(paste("Illegal column type:", info), call. = FALSE)
  }
  col_types
}

check_bool <- function(bool, arg_name) {
  if (!isTRUE(bool) && !identical(bool, FALSE)) {
    stop("`", arg_name, "` must be either TRUE or FALSE", call. = FALSE)
  }
  bool
}

check_non_negative_integer <- function(i, arg_name) {
  if (
    length(i) != 1 || !is.numeric(i) || !is_integerish(i) || is.na(i) || i < 0
  ) {
    stop("`", arg_name, "` must be a positive integer", call. = FALSE)
  }
  i
}

## from readr
check_guess_max <- function(
  guess_max,
  max_limit = .Machine$integer.max %/% 100
) {
  guess_max <- check_non_negative_integer(guess_max, "guess_max")
  if (guess_max > max_limit) {
    warning(
      "`guess_max` is a very large value, setting to `",
      max_limit,
      "` to avoid exhausting memory",
      call. = FALSE
    )
    guess_max <- max_limit
  }
  guess_max
}

set_readxl_names <- function(l, .name_repair = "unique") {
  if (is.null(.name_repair)) {
    tibble::as_tibble(l)
  } else {
    tibble::as_tibble(l, .name_repair = .name_repair)
  }
}

test_that("dates respect worksheet date setting", {
  nms <- paste0("X", 1:5)
  d1900 <- read_xls(test_sheet("dates-1900.xls"), col_names = nms)
  d1904 <- read_xls(test_sheet("dates-1904.xls"), col_names = nms)
  d1900loo <- read_xlsx(
    test_sheet("dates-1900-LibreOffice.xlsx"),
    col_names = nms
  )

  expect_equal(d1900, d1904)
  expect_equal(d1900, d1900loo)
  expect_equal(d1900$X1, ISOdate(2000, 01, 01, 0, tz = "UTC"))
})

## #187 Date/times missing a second
test_that("date subsecond rounding works [xlsx]", {
  df <- read_excel(test_sheet("datetime-rounding.xlsx"))
  expect_identical(as.character(df$dttm), df$dttm_string)
})
test_that("date subsecond rounding works [xls]", {
  df <- read_excel(test_sheet("datetime-rounding.xls"))
  expect_identical(as.character(df$dttm), df$dttm_string)
})

## Lotus 1-2-3 leap year bug ----
## #264, #148
test_that("we get correct dates prior to March 1, 1900, in 1900 date system [xlsx]", {
  expect_snapshot(
    df <- read_excel(
      test_sheet("dates-leap-year-1900-xlsx.xlsx"),
      col_types = c("date", "text", "logical")
    )
  )
  dttms <- as.POSIXct(df$dttm_string, format = "%Y-%m-%d %H:%M:%S", tz = "UTC")
  leap_day <- df$dttm_string == "1900-02-29 08:00:00"
  expect_identical(df$dttm[!leap_day], dttms[!leap_day])
  expect_true(is.na(df$dttm[leap_day]))
})

## Lotus 1-2-3 leap year bug
## #264, #148
test_that("we get correct dates prior to March 1, 1900, in 1900 date system [xls]", {
  expect_snapshot(
    df <- read_excel(
      test_sheet("dates-leap-year-1900-xls.xls"),
      col_types = c("date", "text", "logical")
    )
  )
  dttms <- as.POSIXct(df$dttm_string, format = "%Y-%m-%d %H:%M:%S", tz = "UTC")
  leap_day <- df$dttm_string == "1900-02-29 08:00:00"
  expect_identical(df$dttm[!leap_day], dttms[!leap_day])
  expect_true(is.na(df$dttm[leap_day]))
})

# https://github.com/tidyverse/readxl/issues/388
test_that("colors in number formats aren't misinterpreted as dates", {
  # <numFmts count="8">
  #   <numFmt numFmtId="165" formatCode="[Red]0"/>
  #   <numFmt numFmtId="166" formatCode="[Black]0"/>
  #   <numFmt numFmtId="167" formatCode="[Green]0"/>
  #   <numFmt numFmtId="168" formatCode="[White]0"/>
  #   <numFmt numFmtId="169" formatCode="[Blue]0"/>
  #   <numFmt numFmtId="170" formatCode="[Magenta]0"/>
  #   <numFmt numFmtId="171" formatCode="[Yellow]0"/>
  #   <numFmt numFmtId="172" formatCode="[Cyan]0"/>
  # </numFmts>
  expect_no_warning(
    # rather than "Expecting numeric in A1 / R1C1: got a date" etc.
    read_xlsx(
      test_sheet("color-date-xlsx.xlsx"),
      col_names = "X1",
      col_types = "numeric"
    )
  )
  expect_no_warning(
    # rather than "Expecting numeric in A1 / R1C1: got a date"
    read_xls(
      test_sheet("color-date-xls.xls"),
      col_names = "X1",
      col_types = "numeric"
    )
  )

  # <numFmts count="8">
  #   <numFmt numFmtId="165" formatCode="[red]0"/>
  #   <numFmt numFmtId="166" formatCode="[black]0"/>
  #   <numFmt numFmtId="167" formatCode="[green]0"/>
  #   <numFmt numFmtId="168" formatCode="[white]0"/>
  #   <numFmt numFmtId="169" formatCode="[blue]0"/>
  #   <numFmt numFmtId="170" formatCode="[magenta]0"/>
  #   <numFmt numFmtId="171" formatCode="[yellow]0"/>
  #   <numFmt numFmtId="172" formatCode="[cyan]0"/>
  # </numFmts>
  expect_no_warning(
    # rather than "Expecting numeric in A1 / R1C1: got a date"
    read_xlsx(
      test_sheet("color-date-lowercase-xlsx.xlsx"),
      col_names = "X1",
      col_types = "numeric"
    )
  )
})

# https://github.com/tidyverse/readxl/issues/633
test_that("Swiss Francs (CHF) aren't misinterpreted as dates", {
  # <numFmts count="2">
  #   <numFmt numFmtId="164" formatCode="#,##0.00\ [$CHF]"/>
  #   <numFmt numFmtId="165" formatCode="#,##0.00\ [$EUR]"/>
  # </numFmts>
  dat <- read_xlsx(test_sheet("currency-formats-xlsx.xlsx"))
  expect_true(is.numeric(dat$cost_EUR))
  expect_true(is.numeric(dat$cost_CHF))
  expect_true(is.numeric(dat$cost_mixed))
})

test_that("col_names = FALSE mimics missing column names [xlsx]", {
  df1 <- read_excel(
    test_sheet("no-yes-col-names.xlsx"),
    sheet = "no-col-names",
    col_names = FALSE
  )
  df2 <- read_excel(
    test_sheet("no-yes-col-names.xlsx"),
    sheet = "yes-col-names",
    skip = 1,
    col_names = c("", "")
  )
  df3 <- read_excel(
    test_sheet("no-yes-col-names.xlsx"),
    ## A1 and B1 aren't truly empty -- contain invisible single quotes, so we
    ## don't skip over them
    sheet = "empty-col-names"
  )
  expect_identical(df1, df2)
  expect_identical(df2, df3)
})

test_that("col_names = FALSE mimics missing column names [xls]", {
  df1 <- read_excel(
    test_sheet("no-yes-col-names.xls"),
    sheet = "no-col-names",
    col_names = FALSE
  )
  df2 <- read_excel(
    test_sheet("no-yes-col-names.xls"),
    sheet = "yes-col-names",
    skip = 1,
    col_names = c("", "")
  )
  df3 <- read_excel(
    test_sheet("no-yes-col-names.xls"),
    ## A1 and B1 aren't truly empty -- contain invisible single quotes, so we
    ## don't skip over them
    sheet = "empty-col-names"
  )
  expect_identical(df1, df2)
  expect_identical(df2, df3)
})

test_that("missing column names are populated", {
  nms <- c("...1", "...3")
  df <- read_excel(test_sheet("unnamed-duplicated-columns.xlsx"))
  expect_identical(names(df)[c(1, 3)], nms)
  df <- read_excel(test_sheet("unnamed-duplicated-columns.xls"))
  expect_identical(names(df)[c(1, 3)], nms)
})

test_that("column names are de-duplicated", {
  nm <- "var2...4"

  df <- read_excel(test_sheet("unnamed-duplicated-columns.xlsx"))
  expect_identical(names(df)[4], nm)
  df <- read_excel(test_sheet("unnamed-duplicated-columns.xls"))
  expect_identical(names(df)[4], nm)
})

test_that("wrong length column names are rejected", {
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xlsx.xlsx"), col_names = LETTERS[1:3])
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("iris-excel-xls.xls"), col_names = LETTERS[1:3])
  )
})

test_that("column_names can anticipate skipping", {
  ## xlsx
  df <- read_excel(
    test_sheet("iris-excel-xlsx.xlsx"),
    col_names = c("one", "two", "three"),
    skip = 1,
    col_types = c("numeric", "numeric", "skip", "skip", "text")
  )
  expect_identical(dim(df), c(150L, 3L))
  expect_identical(names(df), c("one", "two", "three"))

  ## xls
  df <- read_excel(
    test_sheet("iris-excel-xls.xls"),
    col_names = c("one", "two", "three"),
    skip = 1,
    col_types = c("numeric", "numeric", "skip", "skip", "text")
  )
  expect_identical(dim(df), c(150L, 3L))
  expect_identical(names(df), c("one", "two", "three"))
})

test_that(".name_repair is passed through to tibble", {
  expect_colnames <- function(df, expected) {
    expect_identical(colnames(df), expected)
  }

  ## default is "unique"
  nms <- c("a b...1", "a b...2", "...3", "c%&$")
  xlsx <- read_excel(test_sheet("names-need-repair-xlsx.xlsx"))
  expect_colnames(xlsx, nms)
  xls <- read_excel(test_sheet("names-need-repair-xls.xls"))
  expect_colnames(xls, nms)

  ## "universal" names are available
  nms <- c("a.b...1", "a.b...2", "...3", "c...")
  xlsx <- read_excel(
    test_sheet("names-need-repair-xlsx.xlsx"),
    .name_repair = "universal"
  )
  expect_colnames(xlsx, nms)
  xls <- read_excel(
    test_sheet("names-need-repair-xls.xls"),
    .name_repair = "universal"
  )
  expect_colnames(xls, nms)

  ## "minimal" names are available
  nms <- c("", "var2", "", "var2")
  xlsx <- read_excel(
    test_sheet("unnamed-duplicated-columns.xlsx"),
    .name_repair = "minimal"
  )
  expect_colnames(xlsx, nms)
  xls <- read_excel(
    test_sheet("unnamed-duplicated-columns.xls"),
    .name_repair = "minimal"
  )
  expect_colnames(xls, nms)

  ## specify name repair as a built-in function
  nms <- c(
    "SEPAL.LENGTH",
    "SEPAL.WIDTH",
    "PETAL.LENGTH",
    "PETAL.WIDTH",
    "SPECIES"
  )
  xlsx <- read_excel(test_sheet("iris-excel-xlsx.xlsx"), .name_repair = toupper)
  expect_colnames(xlsx, nms)
  xls <- read_excel(test_sheet("iris-excel-xls.xls"), .name_repair = toupper)
  expect_colnames(xls, nms)

  ## specify name repair as a custom function
  nms <- c(
    "sepal_length",
    "sepal_width",
    "petal_length",
    "petal_width",
    "species"
  )
  custom_name_repair <- function(nms) tolower(gsub("[.]", "_", nms))
  xlsx <- read_excel(
    test_sheet("iris-excel-xlsx.xlsx"),
    .name_repair = custom_name_repair
  )
  expect_colnames(xlsx, nms)
  xls <- read_excel(
    test_sheet("iris-excel-xls.xls"),
    .name_repair = custom_name_repair
  )
  expect_colnames(xls, nms)

  ## specify name repair as an anonymous function
  nms <- c("wei", "fee")
  xlsx <- read_excel(
    readxl_example("datasets.xlsx"),
    sheet = "chickwts",
    .name_repair = ~ substr(.x, start = 1, stop = 3)
  )
  expect_colnames(xlsx, nms)
  xls <- read_excel(
    readxl_example("datasets.xls"),
    sheet = "chickwts",
    .name_repair = ~ substr(.x, start = 1, stop = 3)
  )
  expect_colnames(xls, nms)
})

test_that("simple use of n_max works and does not affect col name reading", {
  ## xlsx
  df <- read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = 1)
  expect_identical(nrow(df), 1L)
  df <- read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = 0)
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 5L)
  expect_identical(names(df), names(iris))

  ## xls
  df <- read_excel(test_sheet("iris-excel-xls.xls"), n_max = 1)
  expect_identical(nrow(df), 1L)
  df <- read_excel(test_sheet("iris-excel-xls.xls"), n_max = 0)
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 5L)
  expect_identical(names(df), names(iris))
})

test_that("n_max = 0 and col_names = FALSE gives empty tibble", {
  ## xlsx
  df <- read_excel(
    test_sheet("skipping.xlsx"),
    sheet = "two_occupied_rows",
    n_max = 0,
    col_names = FALSE
  )
  expect_identical(df, tibble::tibble())

  ## xls
  df <- read_excel(
    test_sheet("skipping.xls"),
    sheet = "two_occupied_rows",
    n_max = 0,
    col_names = FALSE
  )
  expect_identical(df, tibble::tibble())
})

test_that("n_max is upper bound on nrows, if it causes trailing blank row", {
  ## xlsx
  df <- read_excel(
    test_sheet("skipping.xlsx"),
    sheet = "two_occupied_rows",
    n_max = 3
  )
  expect_identical(nrow(df), 2L)

  ## xls
  df <- read_excel(
    test_sheet("skipping.xls"),
    sheet = "two_occupied_rows",
    n_max = 3
  )
  expect_identical(nrow(df), 2L)
})

test_that("n_max can affect ncols, if prevents read of data in a col [xlsx]", {
  ## xlsx
  df <- read_excel(
    test_sheet("skipping.xlsx"),
    sheet = "two_occupied_rows",
    n_max = 0
  )
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 1L)
  df <- read_excel(
    test_sheet("skipping.xlsx"),
    sheet = "two_occupied_rows",
    skip = 1,
    n_max = 0
  )
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 1L)
})

test_that("n_max can affect ncols, if prevents read of data in a col [xls]", {
  ## xls
  df <- read_excel(
    test_sheet("skipping.xls"),
    sheet = "two_occupied_rows",
    n_max = 0
  )
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 1L)
  df <- read_excel(
    test_sheet("skipping.xls"),
    sheet = "two_occupied_rows",
    skip = 1,
    n_max = 0
  )
  expect_identical(nrow(df), 0L)
  expect_identical(ncol(df), 1L)
})

test_that("n_max = nrows in dense sheet when col_names = FALSE", {
  ## xlsx
  df <- read_excel(
    test_sheet("iris-excel-xlsx.xlsx"),
    n_max = 18,
    col_names = FALSE
  )
  expect_identical(nrow(df), 18L)

  ## xls
  df <- read_excel(
    test_sheet("iris-excel-xls.xls"),
    n_max = 18,
    col_names = FALSE
  )
  expect_identical(nrow(df), 18L)
})

test_that("n_max directive survives implicit skipping of empty rows [xlsx]", {
  ## col_names = TRUE
  explicit <-
    read_excel(test_sheet("geometry.xlsx"), skip = 2, n_max = 1)
  implicit_skip_all <-
    read_excel(test_sheet("geometry.xlsx"), n_max = 1)
  mixed_skip <-
    read_excel(test_sheet("geometry.xlsx"), skip = 1, n_max = 1)
  expect_identical(explicit, implicit_skip_all)
  expect_identical(explicit, mixed_skip)

  ## col_names = FALSE
  explicit <-
    read_excel(
      test_sheet("geometry.xlsx"),
      skip = 2,
      n_max = 1,
      col_names = FALSE
    )
  implicit_skip_all <-
    read_excel(test_sheet("geometry.xlsx"), n_max = 1, col_names = FALSE)
  mixed_skip <-
    read_excel(
      test_sheet("geometry.xlsx"),
      skip = 1,
      n_max = 1,
      col_names = FALSE
    )
  expect_identical(explicit, implicit_skip_all)
  expect_identical(explicit, mixed_skip)
})

test_that("n_max directive survives implicit skipping of empty rows [xls]", {
  ## col_names = TRUE
  explicit <-
    read_excel(test_sheet("geometry.xls"), skip = 2, n_max = 1)
  implicit_skip_all <-
    read_excel(test_sheet("geometry.xls"), n_max = 1)
  mixed_skip <-
    read_excel(test_sheet("geometry.xls"), skip = 1, n_max = 1)
  expect_identical(explicit, implicit_skip_all)
  expect_identical(explicit, mixed_skip)

  ## col_names = FALSE
  explicit <-
    read_excel(
      test_sheet("geometry.xls"),
      skip = 2,
      n_max = 1,
      col_names = FALSE
    )
  implicit_skip_all <-
    read_excel(test_sheet("geometry.xls"), n_max = 1, col_names = FALSE)
  mixed_skip <-
    read_excel(
      test_sheet("geometry.xls"),
      skip = 1,
      n_max = 1,
      col_names = FALSE
    )
  expect_identical(explicit, implicit_skip_all)
  expect_identical(explicit, mixed_skip)
})

## testing of the unexported standardise_limits() ---------------------

limitize <- function(x) {
  stopifnot(length(x) == 4)
  x <- as.integer(x)
  setNames(x, c("min_row", "max_row", "min_col", "max_col"))
}

test_that("we can say 'read nothing' via n_max and col_names", {
  ## n_max = 0 and col_names is not TRUE --> read nothing
  l <- standardise_limits(
    range = NULL,
    skip = 0,
    n_max = 0,
    has_col_names = FALSE
  )
  expect_identical(l, limitize(c(-2, -1, -1, -1)))
  ## min_row max_row min_col max_col
  ##      -2      -1      -1      -1

  ## it should not matter what skip is
  l2 <- standardise_limits(
    range = NULL,
    skip = sample(1:100, 1),
    n_max = 0,
    has_col_names = FALSE
  )
  expect_identical(l, l2)
})

test_that("we can request exactly 1 row for col_names via n_max and col_names", {
  my_skip <- sample(0:100, 1)
  l <- standardise_limits(
    range = NULL,
    skip = my_skip,
    n_max = 0,
    has_col_names = TRUE
  )
  expect_identical(l, limitize(c(my_skip, my_skip, -1, -1)))
})

test_that("we can request n rows for data via n_max and skip doesn't matter", {
  my_skip <- sample(0:100, 1)
  n <- sample(1:100, 1)
  l <- standardise_limits(
    range = NULL,
    skip = my_skip,
    n_max = n,
    has_col_names = TRUE
  )
  expect_identical(l, limitize(c(my_skip, my_skip + n, -1, -1)))

  my_skip <- sample(0:100, 1)
  n <- sample(1:100, 1)
  l <- standardise_limits(
    range = NULL,
    skip = my_skip,
    n_max = n,
    has_col_names = FALSE
  )
  expect_identical(l, limitize(c(my_skip, my_skip + n - 1, -1, -1)))
})

## testing via read_excel() -------------------------------------------

test_that("geometry sheet is identical in xls and xlsx and shrink wraps by default", {
  ref <- tibble::tibble(
    var1 = c("aa", "dd", "gg"),
    var2 = c("bb", "ee", "hh"),
    var3 = c("cc", "ff", "ii")
  )
  xls <- read_excel(test_sheet("geometry.xls"))
  xlsx <- read_excel(test_sheet("geometry.xlsx"))
  expect_identical(xls, xlsx)
  expect_identical(xls, ref)
})

## at time of writing, clippy/geometry.key contains useful sketches
## for choosing test cases
## they are not comprehensive, but cover a very large number of scenarios

test_that("exact range request for data rectangle works", {
  ref <- tibble::tibble(
    var1 = c("aa", "dd", "gg"),
    var2 = c("bb", "ee", "hh"),
    var3 = c("cc", "ff", "ii")
  )
  xls <- read_excel(test_sheet("geometry.xls"), range = "B3:D6")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "B3:D6")
  expect_identical(xls, xlsx)
  expect_identical(xls, ref)
})

test_that("range request for proper subset of data rectangle works", {
  ref <- tibble::tibble(
    var1 = c("aa"),
    var2 = c("bb")
  )
  xls <- read_excel(test_sheet("geometry.xls"), range = "B3:C4")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "B3:C4")
  expect_identical(xls, xlsx)
  expect_identical(xls, ref)
})

test_that("range requests that run off one or more edges of data rectangle work", {
  ## all four edges
  xls <- read_excel(test_sheet("geometry.xls"), range = "A2:E7")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "A2:E7")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(5L, 5L))

  ## top edge only, partial
  xls <- read_excel(test_sheet("geometry.xls"), range = "B2:C3")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "B2:C3")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 2L))

  ## top and right, partial
  xls <- read_excel(test_sheet("geometry.xls"), range = "D2:E3")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "D2:E3")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 2L))

  ## right edge only, partial
  xls <- read_excel(test_sheet("geometry.xls"), range = "C4:E5")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "C4:E5")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 3L))

  ## left and right edges, partial
  xls <- read_excel(test_sheet("geometry.xls"), range = "A4:E5")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "A4:E5")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 5L))

  ## left and bottom edges, partial
  xls <- read_excel(test_sheet("geometry.xls"), range = "A6:B7")
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = "A6:B7")
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 2L))
})

test_that("requests that use cell_rows() only work", {
  ## rows are within the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_rows(2:3))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_rows(2:3))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 3L))

  ## rows run past the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_rows(3:7))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_rows(3:7))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(4L, 3L))

  ## rows start before the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_rows(1:4))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_rows(1:4))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 3L))

  ## rows start before and run past the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_rows(1:7))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_rows(1:7))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(6L, 3L))

  ## unspecified upper row bound
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_rows(c(3, NA)))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_rows(c(3, NA)))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 3L))
  ## unspecified lower bound not relevant because cellranger handles
})

test_that("requests that use cell_cols() only work", {
  ## cols are within the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_cols(2:3))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_cols(2:3))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 2L))

  ## cols run past the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_cols(2:5))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_cols(2:5))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 4L))

  ## cols start before the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_cols(1:3))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_cols(1:3))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 3L))

  ## cols start before and run past the data
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_cols(1:5))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_cols(1:5))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 5L))

  ## unspecified upper col bound
  xls <- read_excel(test_sheet("geometry.xls"), range = cell_cols(c(3, NA)))
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = cell_cols(c(3, NA)))
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(3L, 2L))
  ## unspecified lower bound not relevant because cellranger handles
})

test_that("open rectangles work", {
  ## only worth testing openness on right and bottom
  ## cellranger handles openness on left and top

  ## open on bottom
  lims <- cell_limits(c(5, 3), c(NA, 5))
  xls <- read_excel(test_sheet("geometry.xls"), range = lims)
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = lims)
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(1L, 3L))

  ## open on right
  lims <- cell_limits(c(3, 3), c(5, NA))
  xls <- read_excel(test_sheet("geometry.xls"), range = lims)
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = lims)
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(2L, 2L))

  ## open on bottom and right
  lims <- cell_limits(c(4, 3), c(NA, NA))
  xls <- read_excel(test_sheet("geometry.xls"), range = lims)
  xlsx <- read_excel(test_sheet("geometry.xlsx"), range = lims)
  expect_identical(xls, xlsx)
  expect_identical(dim(xls), c(2L, 2L))
})

test_that("trim_ws is default and it works", {
  ## data
  xls <- read_excel(test_sheet("whitespace-xls.xls"), col_names = FALSE)
  xlsx <- read_excel(test_sheet("whitespace-xlsx.xlsx"), col_names = FALSE)
  expect_identical(xls[[1]], trimws(xls[[1]]))
  expect_identical(xlsx[[1]], trimws(xlsx[[1]]))
  ## the 4th cell is "\t   \t"
  ## xls reports this but xlsx does not
  ## does xlsx return "" for cells containing only whitespace?
  expect_identical(xls[[1]], xlsx[[1]])

  ## column names
  xls <- read_excel(test_sheet("whitespace-xls.xls"))
  xlsx <- read_excel(test_sheet("whitespace-xlsx.xlsx"))
  expect_identical(names(xls), trimws(names(xls)))
  expect_identical(names(xlsx), trimws(names(xlsx)))
  expect_identical(names(xls), names(xlsx))
})

test_that("trim_ws = FALSE preserves whitespace", {
  ## data
  xls <- read_excel(
    test_sheet("whitespace-xls.xls"),
    col_names = FALSE,
    trim_ws = FALSE
  )
  xlsx <- read_excel(
    test_sheet("whitespace-xlsx.xlsx"),
    col_names = FALSE,
    trim_ws = FALSE
  )
  expect_false(identical(xls[[1]], trimws(xls[[1]])))
  expect_false(identical(xlsx[[1]], trimws(xlsx[[1]])))
  ## I have a whitespace-only cell with contents: "\t   \t"
  ## which survives import from xls, but not from xlsx
  ws_only <- grepl("^\\s*$", xls[[1]])
  expect_identical(xls[[1]][!ws_only], xlsx[[1]][!ws_only])

  ## column names
  xls <- read_excel(test_sheet("whitespace-xls.xls"), trim_ws = FALSE)
  xlsx <- read_excel(test_sheet("whitespace-xlsx.xlsx"), trim_ws = FALSE)
  expect_false(identical(names(xls), trimws(names(xls))))
  expect_false(identical(names(xlsx), trimws(names(xlsx))))
  expect_identical(names(xls), names(xlsx))
})

test_that("whitespace-flanked na strings match when trim_ws = TRUE", {
  xls <- read_excel(
    test_sheet("whitespace-xls.xls"),
    sheet = "logical_and_NA",
    na = ":-)"
  )
  xlsx <- read_excel(
    test_sheet("whitespace-xlsx.xlsx"),
    sheet = "logical_and_NA",
    na = ":-)"
  )
  expect_true(is.numeric(xls$numeric))
  expect_true(is.numeric(xlsx$numeric))
  expect_true(is.na(xls[[2, 1]]))
  expect_true(is.na(xlsx[[2, 1]]))
})

test_that("whitespace-flanked na strings do not match when trim_ws = FALSE", {
  xls <- read_excel(
    test_sheet("whitespace-xls.xls"),
    sheet = "logical_and_NA",
    na = ":-)",
    trim_ws = FALSE
  )
  xlsx <- read_excel(
    test_sheet("whitespace-xlsx.xlsx"),
    sheet = "logical_and_NA",
    na = ":-)",
    trim_ws = FALSE
  )
  expect_true(is.character(xls$numeric))
  expect_true(is.character(xlsx$numeric))
  expect_identical(xls[[2, 1]], "  :-)  ")
  expect_identical(xlsx[[2, 1]], "  :-)  ")
})

test_that("can read document from google doc", {
  iris_1 <- read_excel(test_sheet("iris-excel-xlsx.xlsx"))
  iris_2 <- read_excel(test_sheet("iris-google-doc.xlsx"))

  expect_equal(iris_1, iris_2)
})

## #180, #152, #99
## Some 3rd-party s/w writes xls where lastcol is 0-indexed, like lastrow
## Changed an inequality in xls_cell() in  xls.c to accomodate this
## WriteXLS is (or, rather, wraps) such s/w, so it's good source of such xls.
## WriteXLS::WriteXLS(head(mtcars), file.path("tests", "testthat", "sheets", "mtcars.xls"))
test_that("can tolerate xls that underreports number of columns", {
  df <- read_excel(test_sheet("mtcars.xls"))
  expect_identical(ncol(df), ncol(mtcars))
})

## #80
## The infamous Ekaterinburg sheet is written by an unspecified BI tool.
## Tricky for several reasons:
##   * Worksheet target paths demand full lookup (#233)
##   * Worksheet target paths are prefixed with `/xl/` (#294)
##   * Nonstandard XML namespace prefixes (#295)
test_that("we can finally read Ekaterinburg", {
  ek <- read_excel(test_sheet("Ekaterinburg_IP_9.xlsx"), skip = 2)
  expect_identical(ek[[1, 2]], "27.05.2004")
})

## #309
## A BIFF5 xls from an unspecified 3rd party tool, that uses a very antiquated
## practice of storing text strings in LABEL records.
## Exposed the fact that the libxls patch in #293 is beneficial for indexing
## the shared string table, but causes difficulty when parsing LABEL records.
## We have a small patch now in libxls for that.
test_that("we can read the BIFF5, LABEL record sheet", {
  df <- read_excel(
    test_sheet("biff5-label-records.xls"),
    skip = 2,
    na = c("", "--")
  )
  expect_identical(dim(df), c(14L, 4L))
  expect_identical(df$Date[c(1, 14)], c("21/01/2017", "21/01/2017"))
  expect_identical(df$Time[c(1, 14)], c("01:00", "14:00"))
})


## https://github.com/tidyverse/readxl/pull/429
## <c r="C2" s="1" t="str"><f>A2 + B2</f></c>
test_that("formula cell with no v node does not cause crash", {
  df <- read_excel(test_sheet("missing-v-node-xlsx.xlsx"))
  expect_identical(df$`A + B`, NA)
})

## https://github.com/tidyverse/readxl/issues/435
## https://source.opennews.org/articles/how-we-found-new-patterns-la-homeless-arrest/
## LAPD uses a tool to produce xlsx that implements the minimal SpreadsheetML
## package structure described on pp65-66 of ECMA 5th edition
test_that("we can read LAPD arrest sheets", {
  expect_no_error(
    lapd <- read_excel(test_sheet("los-angeles-arrests-xlsx.xlsx"), skip = 2)
  )
  expect_identical(dim(lapd), c(193L, 36L))
  expect_match(lapd$ARR_LOC[9], "HOLLYWOOD")
  expect_identical(lapd$CHG_DESC[27], "EX CON W/ A GUN")
})

# https://github.com/tidyverse/readxl/issues/611
# xls file produced by ABBYY FineReader (OCR of PDFs)
# inspired libxls to add support for rich-text strings in BIFF5
# https://github.com/libxls/libxls/commit/b6d9d872756f69780b743dbaec9cd2ec30c37740
test_that("we can read xls from ABBYY FineReader", {
  expect_no_error(
    abbyy <- read_excel(
      test_sheet("biff5-rich-text-string.xls"),
      col_names = FALSE,
      n_max = 1
    )
  )
  expect_equal(nrow(abbyy), 1)
  expect_equal(ncol(abbyy), 1)
  expect_match(abbyy[[1, 1]], "^ELECTORAL")
})

skipping_xlsx <- test_sheet("skipping.xlsx")
skipping_xls <- test_sheet("skipping.xls")
ref <- tibble::tribble(
  ~var1,
  ~var2,
  NA,
  NA,
  "v2,1",
  "v2,2",
  NA,
  NA,
  "v4,1",
  "v4,2"
)

test_that("leading blank rows are implicitly skipped", {
  xlsx <- read_excel(skipping_xlsx, sheet = "two_blank_rows")
  xls <- read_excel(skipping_xls, sheet = "two_blank_rows")
  expect_identical(xlsx, ref)
  expect_identical(xls, ref)
})

test_that("leading blank rows can be explicitly skipped", {
  xlsx <- read_excel(skipping_xlsx, sheet = "two_blank_rows", skip = 2)
  xls <- read_excel(skipping_xls, sheet = "two_blank_rows", skip = 2)
  expect_identical(xlsx, ref)
  expect_identical(xls, ref)
})

test_that("leading blank rows can be implicitly AND explicitly skipped", {
  xlsx <- read_excel(skipping_xlsx, sheet = "two_blank_rows", skip = 1)
  xls <- read_excel(skipping_xls, sheet = "two_blank_rows", skip = 1)
  expect_identical(xlsx, ref)
  expect_identical(xls, ref)
})

test_that("failure to skip junk leads to garbage df but no error", {
  out <- read_excel(skipping_xlsx, sheet = "occupied_row_and_blank_row")
  expect_identical(out$`blah blah`, c(NA, "var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out[[2]], c(NA, "var2", NA, "v2,2", NA, "v4,2"))

  out <- read_excel(skipping_xls, sheet = "occupied_row_and_blank_row")
  expect_identical(out$`blah blah`, c(NA, "var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out[[2]], c(NA, "var2", NA, "v2,2", NA, "v4,2"))

  out <- read_excel(skipping_xlsx, sheet = "two_occupied_rows")
  expect_identical(out$`blah blah`, c(NA, "var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out[[2]], c("yada yada", "var2", NA, "v2,2", NA, "v4,2"))

  out <- read_excel(skipping_xls, sheet = "two_occupied_rows")
  expect_identical(out$`blah blah`, c(NA, "var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out[[2]], c("yada yada", "var2", NA, "v2,2", NA, "v4,2"))

  out <- read_excel(skipping_xlsx, sheet = "two_occupied_rows", skip = 1)
  expect_identical(out[[1]], c("var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out$`yada yada`, c("var2", NA, "v2,2", NA, "v4,2"))

  out <- read_excel(skipping_xls, sheet = "two_occupied_rows", skip = 1)
  expect_identical(out[[1]], c("var1", NA, "v2,1", NA, "v4,1"))
  expect_identical(out$`yada yada`, c("var2", NA, "v2,2", NA, "v4,2"))
})

test_that("explicit skip of leading junk, implicit skip of blank rows", {
  xlsx <- read_excel(
    skipping_xlsx,
    sheet = "occupied_row_and_blank_row",
    skip = 1
  )
  xls <- read_excel(
    skipping_xls,
    sheet = "occupied_row_and_blank_row",
    skip = 1
  )
  expect_identical(xlsx, ref)
  expect_identical(xls, ref)
})

test_that("explicit skip of leading junk and blank rows", {
  xlsx <- read_excel(
    skipping_xlsx,
    sheet = "occupied_row_and_blank_row",
    skip = 2
  )
  xls <- read_excel(
    skipping_xls,
    sheet = "occupied_row_and_blank_row",
    skip = 2
  )
  expect_identical(xlsx, ref)
  expect_identical(xls, ref)
})

test_that("explicit skip of leading junk", {
  xlsx <- read_excel(skipping_xlsx, sheet = "two_occupied_rows", skip = 2)
  xls <- read_excel(skipping_xls, sheet = "two_occupied_rows", skip = 2)
  expect_identical(ref, xlsx)
  expect_identical(ref, xls)
})

test_that("illegal col_types are rejected", {
  expect_snapshot(
    error = TRUE,
    read_excel(
      test_sheet("types.xlsx"),
      col_types = c("foo", "numeric", "text", "bar")
    )
  )
})

test_that("request for 'blank' col type gets deprecation message and fix", {
  expect_snapshot(
    read_excel(
      test_sheet("types.xlsx"),
      col_types = rep_len(c("blank", "text"), length.out = 5)
    )
  )
})

test_that("invalid col_types are rejected", {
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("types.xlsx"), col_types = character()),
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("types.xlsx"), col_types = 1:3)
  )
  expect_snapshot(
    error = TRUE,
    read_excel(test_sheet("types.xlsx"), col_types = c(NA, "text", "numeric")),
  )
})

test_that("col_types can be specified", {
  df <- read_excel(
    test_sheet("iris-excel-xlsx.xlsx"),
    col_types = c("numeric", "text", "numeric", "numeric", "text")
  )
  expect_true(is.character(df[[2]]))
  df <- read_excel(
    test_sheet("iris-excel-xls.xls"),
    col_types = c("numeric", "text", "numeric", "numeric", "text")
  )
  expect_true(is.character(df[[2]]))
})

test_that("col_types are recycled", {
  df <- read_excel(test_sheet("iris-excel-xlsx.xlsx"), col_types = "text")
  expect_match(vapply(df, class, character(1)), "character")
  df <- read_excel(test_sheet("iris-excel-xls.xls"), col_types = "text")
  expect_match(vapply(df, class, character(1)), "character")
})

test_that("types guessed correctly [xlsx]", {
  types <- read_excel(test_sheet("types.xlsx"), sheet = "guess_me")
  expect_true(is.logical(types$blank))
  expect_true(is.logical(types$boolean))
  expect_s3_class(types$date, "POSIXct")
  expect_true(is.numeric(types$numeric))
  expect_true(is.character(types$text))
  expect_true(all(vapply(types, function(x) is.na(x[3]), logical(1))))
})

test_that("types guessed correctly [xls]", {
  types <- read_excel(test_sheet("types.xls"), sheet = "guess_me")
  expect_true(is.logical(types$blank))
  expect_true(is.logical(types$boolean))
  expect_s3_class(types$date, "POSIXct")
  expect_true(is.numeric(types$numeric))
  expect_true(is.character(types$text))
  expect_true(all(vapply(types, function(x) is.na(x[3]), logical(1))))
})

test_that("we can specify some col_types and guess others", {
  ctypes <- c("text", "guess", "guess", "text", "guess")
  exp_cls <- c("character", "logical", "POSIXct", "character", "character")

  df <- read_excel(test_sheet("types.xlsx"), col_types = ctypes)
  cls <- vapply(df, function(x) class(x)[1], character(1))
  expect_equal(cls, exp_cls, ignore_attr = TRUE)

  df <- read_excel(test_sheet("types.xls"), col_types = ctypes)
  cls <- vapply(df, function(x) class(x)[1], character(1))
  expect_equal(cls, exp_cls, ignore_attr = TRUE)
})

test_that("guess_max is honored for col_types", {
  expect_snapshot(
    types <- read_excel(
      test_sheet("types.xlsx"),
      sheet = "guess_max",
      guess_max = 2
    )
  )

  expect_identical(types$string_in_row_3, c(1, 2, NA))

  expect_snapshot(
    types <- read_excel(
      test_sheet("types.xls"),
      sheet = "guess_max",
      guess_max = 2
    )
  )

  expect_identical(types$string_in_row_3, c(1, 2, NA))
})

test_that("wrong length col types generates error", {
  expect_snapshot(
    error = TRUE,
    read_excel(
      test_sheet("iris-excel-xlsx.xlsx"),
      col_types = c("numeric", "text")
    )
  )
  expect_snapshot(
    error = TRUE,
    read_excel(
      test_sheet("iris-excel-xls.xls"),
      col_types = c("numeric", "text")
    )
  )
})

test_that("list column reads data correctly [xlsx]", {
  types <- read_excel(test_sheet("list_type.xlsx"), col_types = "list")
  expect_equal(types$var1[[1]], 1)
  expect_equal(types$var1[[2]], NA)
  expect_equal(types$var1[[3]], "a")
  expect_equal(types$var1[[4]], as.POSIXct("2017-01-01", tz = "UTC"))
  expect_equal(types$var1[[5]], "abc")
  expect_equal(types$var1[[6]], FALSE)
})

test_that("setting `na` works in list columns [xlsx]", {
  na_defined <- read_excel(
    test_sheet("list_type.xlsx"),
    col_types = "list",
    na = "a"
  )
  expect_equal(na_defined$var1[[3]], NA)
})

test_that("list column reads data correctly [xls]", {
  types <- read_excel(test_sheet("list_type.xls"), col_types = "list")
  expect_equal(types$var1[[1]], 1)
  expect_equal(types$var1[[2]], NA)
  expect_equal(types$var1[[3]], "a")
  expect_equal(types$var1[[4]], as.POSIXct("2017-01-01", tz = "UTC"))
  expect_equal(types$var1[[5]], "abc")
  expect_equal(types$var1[[6]], FALSE)
})

test_that("setting `na` works in list columns [xls]", {
  na_defined <- read_excel(
    test_sheet("list_type.xls"),
    col_types = "list",
    na = "a"
  )
  expect_equal(na_defined$var1[[3]], NA)
})

## #385: logical-guessed column could end up with multiple pathological `TRUE`
## values for subsequent cells holding numeric data
## refines fix initiated in #398
test_that("numeric is correctly coerced to logical [xlsx]", {
  expect_snapshot(
    df <- read_xlsx(test_sheet("missing-values-xlsx.xlsx"), guess_max = 0)
  )

  expect_identical(df$z, c(NA, TRUE, TRUE))
  expect_equal(sum(df$z, na.rm = TRUE), 2)
})

test_that("numeric is correctly coerced to logical [xls]", {
  expect_snapshot(
    df <- read_xls(test_sheet("missing-values-xls.xls"), guess_max = 0)
  )

  expect_identical(df$z, c(NA, TRUE, TRUE))
  expect_equal(sum(df$z, na.rm = TRUE), 2)
})

test_that("blanks in different rows read as missing [xlsx]", {
  blanks <- read_excel(test_sheet("blanks.xlsx"), sheet = "different_rows")
  expect_equal(blanks$x, c(NA, 1))
  expect_equal(blanks$y, c("a", NA))
})

test_that("blanks read as missing [xls]", {
  blanks <- read_excel(test_sheet("blanks.xls"), sheet = "different_rows")
  expect_equal(blanks$x, c(NA, 1))
  expect_equal(blanks$y, c("a", NA))
})

test_that("blanks in same middle row are read as missing [xlsx]", {
  blanks <- read_excel(test_sheet("blanks.xlsx"), sheet = "same_row_middle")
  expect_equal(blanks$x, c(1, NA, 2))
  expect_equal(blanks$y, c("a", NA, "b"))
})

test_that("blanks in same middle row are read as missing [xls]", {
  blanks <- read_excel(test_sheet("blanks.xls"), sheet = "same_row_middle")
  expect_equal(blanks$x, c(1, NA, 2))
  expect_equal(blanks$y, c("a", NA, "b"))
})

test_that("blanks in same, first row are read as missing [xlsx]", {
  blanks <- read_excel(test_sheet("blanks.xlsx"), sheet = "same_row_first")
  expect_equal(blanks$x, c(NA, 1))
  expect_equal(blanks$y, c(NA, "a"))
})

test_that("blanks in same, first row are read as missing [xls]", {
  blanks <- read_excel(test_sheet("blanks.xls"), sheet = "same_row_first")
  expect_equal(blanks$x, c(NA, 1))
  expect_equal(blanks$y, c(NA, "a"))
})

test_that("By default, NA read as text", {
  df <- read_xls(test_sheet("missing-values-xls.xls"))
  expect_equal(df$x, c("NA", "1", "2"))
})

test_that("na arg can be used to map 'NA' to NA [xls]", {
  df <- read_excel(test_sheet("missing-values-xls.xls"), na = "NA")
  expect_equal(df$x, c(NA, 1, 2))
  expect_equal(df$y, c(NA, 1, 2)) # formula column
})

test_that("na arg can be used to map 'NA' to NA [xlsx]", {
  df <- read_excel(test_sheet("missing-values-xlsx.xlsx"), na = "NA")
  expect_equal(df$x, c(NA, 1, 2))
  expect_equal(df$y, c(NA, 1, 2)) # formula column
})

## #401 make sure check against NA strings is done after shared string table
## lookup for affected cells vs. on the index into the shared string table
test_that("na arg works with multiple strings and for shared strings [xlsx]", {
  df <- read_excel(
    test_sheet("numbers-as-na-and-shared-strings-xlsx.xlsx"),
    na = c("1", "d")
  )
  ## shared string table is:
  ## sst[0] = "a"
  ## sst[1] = "b" <-- make sure this does not become NA!
  ## sst[2] = "c"
  ## sst[3] = "d"
  expect_identical(
    df,
    tibble::tribble(
      ~a,
      ~c,
      "b",
      NA
    )
  )
})

test_that("na arg works with multiple strings and for shared strings [xls]", {
  df <- read_excel(
    test_sheet("numbers-as-na-and-shared-strings-xls.xls"),
    na = c("1", "d")
  )
  expect_identical(
    df,
    tibble::tribble(
      ~a,
      ~c,
      "b",
      NA
    )
  )
})

test_that("empty first column gives valid data.frame [xls]", {
  df <- read_excel(test_sheet("missing-first-column.xls"), col_names = FALSE)
  expect_s3_class(df, "tbl_df")
  expect_identical(dim(df), c(3L, 1L))
})

test_that("empty first column gives valid data.frame [xlsx]", {
  df <- read_excel(test_sheet("missing-first-column.xlsx"), col_names = FALSE)
  expect_s3_class(df, "tbl_df")
  expect_identical(dim(df), c(3L, 1L))
})

test_that("empty named column gives NA column", {
  df1 <- read_excel(test_sheet("empty-named-column.xlsx"), col_names = TRUE)
  df2 <- read_excel(test_sheet("empty-named-column.xls"), col_names = TRUE)
  expect_equal(ncol(df1), 4)
  expect_equal(names(df1)[2], "y")
  expect_true(all(is.na(df1$y)))
  expect_true(all(is.logical(df1$y)))
  expect_equal(ncol(df2), 4)
  expect_equal(names(df2)[2], "y")
  expect_true(all(is.na(df2$y)))
  expect_true(all(is.logical(df2$y)))
})

test_that("empty (styled) cells are not loaded, but can survive as NA [xlsx]", {
  ## what's important about this sheet?
  ## contains empty cells with a custom format
  ## therefore they appear in the xml and have a style attribute
  ## where are they?
  ## in the embedded empty columns, w/ and w/o a name
  ## in a trailing empty column WHICH SHOULD BE DROPPED
  ## in some trailing rows WHICH SHOULD BE DROPPED
  out <- read_excel(test_sheet("style-only-cells.xlsx"))
  df <- tibble::tibble(
    var1 = c("val1,1", "val2,1", "val3,1"),
    var2 = NA,
    var3 = c("aa", "bb", "cc"),
    var4 = NA,
    var5 = c(1, 2, 3)
  )
  ## this is not a test re: column names; be robust to tibble version
  names(out)[4] <- "var4"
  expect_equal(out, df)
})

test_that("empty (styled) cells are not loaded, but can survive as NA [xls]", {
  out <- read_excel(test_sheet("style-only-cells.xls"))
  df <- tibble::tibble(
    var1 = c("val1,1", "val2,1", "val3,1"),
    var2 = NA,
    var3 = c("aa", "bb", "cc"),
    var4 = NA,
    var5 = c(1, 2, 3)
  )
  ## this is not a test re: column names; be robust to tibble version
  names(out)[4] <- "var4"
  expect_equal(out, df)
})

#' Get path to readxl example
#'
#' readxl comes bundled with some example files in its `inst/extdata`
#' directory. This function make them easy to access.
#'
#' @param path Name of file. If `NULL`, the example files will be listed.
#' @export
#' @examples
#' readxl_example()
#' readxl_example("datasets.xlsx")
readxl_example <- function(path = NULL) {
  if (is.null(path)) {
    dir(system.file("extdata", package = "readxl"))
  } else {
    system.file("extdata", path, package = "readxl", mustWork = TRUE)
  }
}

# Called only from C++ code, but currently needs to be implemented in R.
zip_buffer <- function(zip_path, file_path) {
  files <- utils::unzip(zip_path, list = TRUE)

  indx <- match(file_path, files$Name)
  if (is.na(indx)) {
    stop("Couldn't find '", file_path, "' in '", zip_path, "'", call. = FALSE)
  }

  size <- files$Length[indx]

  con <- unz(zip_path, file_path, open = "rb")
  on.exit(close(con), add = TRUE)
  readBin(con, raw(), n = size)
}

zip_has_file <- function(zip_path, file_path) {
  file_path %in% utils::unzip(zip_path, list = TRUE)$Name
}

# Generated by cpp11: do not edit by hand

read_xls_ <- function(path, sheet_i, limits, shim, col_names, col_types, na, trim_ws, guess_max, progress) {
  .Call(`_readxl_read_xls_`, path, sheet_i, limits, shim, col_names, col_types, na, trim_ws, guess_max, progress)
}

read_xlsx_ <- function(path, sheet_i, limits, shim, col_names, col_types, na, trim_ws, guess_max, progress) {
  .Call(`_readxl_read_xlsx_`, path, sheet_i, limits, shim, col_names, col_types, na, trim_ws, guess_max, progress)
}

xls_sheets <- function(path) {
  .Call(`_readxl_xls_sheets`, path)
}

xls_date_formats <- function(path) {
  .Call(`_readxl_xls_date_formats`, path)
}

xlsx_sheets <- function(path) {
  .Call(`_readxl_xlsx_sheets`, path)
}

xlsx_strings <- function(path) {
  .Call(`_readxl_xlsx_strings`, path)
}

xlsx_date_formats <- function(path) {
  .Call(`_readxl_xlsx_date_formats`, path)
}

zip_xml <- function(zip_path, file_path) {
  invisible(.Call(`_readxl_zip_xml`, zip_path, file_path))
}

# coercion warnings report correct address

    Code
      read_excel(test_sheet("geometry.xlsx"), sheet = "warning_B6", col_types = "numeric")
    Condition
      Warning:
      Expecting numeric in B6 / R6C2: got 'wtf'
    Output
      # A tibble: 3 x 1
         var1
        <dbl>
      1  1234
      2  2345
      3    NA

---

    Code
      read_excel(test_sheet("geometry.xlsx"), sheet = "warning_AT6", col_types = "numeric")
    Condition
      Warning:
      Expecting numeric in AT6 / R6C46: got 'wtf'
    Output
      # A tibble: 3 x 1
         var1
        <dbl>
      1  1234
      2  2345
      3    NA

---

    Code
      read_excel(test_sheet("geometry.xlsx"), sheet = "warning_AKE6", col_types = "numeric")
    Condition
      Warning:
      Expecting numeric in AKE6 / R6C967: got 'wtf'
    Output
      # A tibble: 3 x 1
         var3
        <dbl>
      1  1234
      2  2345
      3    NA

---

    Code
      read_excel(test_sheet("geometry.xls"), sheet = "warning_B6", col_types = "numeric")
    Condition
      Warning:
      Expecting numeric in B6 / R6C2: got 'wtf'
    Output
      # A tibble: 3 x 1
         var1
        <dbl>
      1  1234
      2  2345
      3    NA

---

    Code
      read_excel(test_sheet("geometry.xls"), sheet = "warning_AT6", col_types = "numeric")
    Condition
      Warning:
      Expecting numeric in AT6 / R6C46: got 'wtf'
    Output
      # A tibble: 3 x 1
         var1
        <dbl>
      1  1234
      2  2345
      3    NA

# illegal col_types are rejected

    Code
      read_excel(test_sheet("types.xlsx"), col_types = c("foo", "numeric", "text",
        "bar"))
    Condition
      Error:
      ! Illegal column type: 'foo' [1], 'bar' [4]

# request for 'blank' col type gets deprecation message and fix

    Code
      read_excel(test_sheet("types.xlsx"), col_types = rep_len(c("blank", "text"),
      length.out = 5))
    Message
      `col_type = "blank"` deprecated. Use "skip" instead.
    Output
      # A tibble: 5 x 2
        boolean numeric
        <chr>   <chr>  
      1 TRUE    1      
      2 FALSE   2      
      3 <NA>    <NA>   
      4 TRUE    3      
      5 FALSE   6      

# invalid col_types are rejected

    Code
      read_excel(test_sheet("types.xlsx"), col_types = character())
    Condition
      Error in `check_col_types()`:
      ! length(col_types) > 0 is not TRUE

---

    Code
      read_excel(test_sheet("types.xlsx"), col_types = 1:3)
    Condition
      Error in `check_col_types()`:
      ! is.character(col_types) is not TRUE

---

    Code
      read_excel(test_sheet("types.xlsx"), col_types = c(NA, "text", "numeric"))
    Condition
      Error in `check_col_types()`:
      ! !anyNA(col_types) is not TRUE

# guess_max is honored for col_types

    Code
      types <- read_excel(test_sheet("types.xlsx"), sheet = "guess_max", guess_max = 2)
    Condition
      Warning:
      Expecting numeric in A4 / R4C1: got 'ab'

---

    Code
      types <- read_excel(test_sheet("types.xls"), sheet = "guess_max", guess_max = 2)
    Condition
      Warning:
      Expecting numeric in A4 / R4C1: got 'ab'

# wrong length col types generates error

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), col_types = c("numeric", "text"))
    Condition
      Error:
      ! Sheet 1 has 5 columns, but `col_types` has length 2.

---

    Code
      read_excel(test_sheet("iris-excel-xls.xls"), col_types = c("numeric", "text"))
    Condition
      Error:
      ! Sheet 1 has 5 columns, but `col_types` has length 2.

# numeric is correctly coerced to logical [xlsx]

    Code
      df <- read_xlsx(test_sheet("missing-values-xlsx.xlsx"), guess_max = 0)
    Condition
      Warning:
      Expecting logical in A2 / R2C1: got 'NA'
      Warning:
      Expecting logical in B2 / R2C2: got 'NA'

# numeric is correctly coerced to logical [xls]

    Code
      df <- read_xls(test_sheet("missing-values-xls.xls"), guess_max = 0)
    Condition
      Warning:
      Expecting logical in A2 / R2C1: got 'NA'
      Warning:
      Expecting logical in B2 / R2C2: got 'NA'

# xlsx is not read as xls and vice versa

    Code
      read_xls(test_sheet("iris-excel-xlsx.xlsx"))
    Condition
      Error:
      ! 
        filepath: 'VOLATILE_FILEPATH'
        libxls error: Unable to open file

---

    Code
      read_xlsx(test_sheet("iris-excel-xls.xls"))
    Condition
      Error in `utils::unzip()`:
      ! zip file 'VOLATILE_FILEPATH' cannot be opened

# non-existent file throws error

    Code
      read_excel("foo")
    Condition
      Error:
      ! `path` does not exist: 'foo'

# read_excel catches invalid guess_max

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), guess_max = NA)
    Condition
      Error:
      ! `guess_max` must be a positive integer

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), guess_max = -1)
    Condition
      Error:
      ! `guess_max` must be a positive integer

---

    Code
      out <- read_excel(test_sheet("iris-excel-xlsx.xlsx"), guess_max = Inf)
    Condition
      Warning:
      `guess_max` is a very large value, setting to `21474836` to avoid exhausting memory

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), guess_max = NULL)
    Condition
      Error:
      ! `guess_max` must be a positive integer

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), guess_max = 1:2)
    Condition
      Error:
      ! `guess_max` must be a positive integer

# read_excel catches invalid n_max

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = NA)
    Condition
      Error:
      ! `n_max` must be a positive integer

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = -1)
    Condition
      Error:
      ! `n_max` must be a positive integer

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = NULL)
    Condition
      Error:
      ! `n_max` must be a positive integer

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), n_max = 1:2)
    Condition
      Error:
      ! `n_max` must be a positive integer

# sheet must be integer or string

    Code
      read_excel(test_sheet("mtcars.xls"), sheet = TRUE)
    Condition
      Error:
      ! `sheet` must be either an integer or a string.

# trim_ws must be a logical

    Code
      read_excel(test_sheet("mtcars.xls"), trim_ws = "yes")
    Condition
      Error:
      ! `trim_ws` must be either TRUE or FALSE

# we get correct dates prior to March 1, 1900, in 1900 date system [xlsx]

    Code
      df <- read_excel(test_sheet("dates-leap-year-1900-xlsx.xlsx"), col_types = c(
        "date", "text", "logical"))
    Condition
      Warning:
      NA inserted for impossible 1900-02-29 datetime

# we get correct dates prior to March 1, 1900, in 1900 date system [xls]

    Code
      df <- read_excel(test_sheet("dates-leap-year-1900-xls.xls"), col_types = c(
        "date", "text", "logical"))
    Condition
      Warning:
      NA inserted for impossible 1900-02-29 datetime

# contaminated, explicit logical is read as logical

    Code
      df <- read_excel(test_sheet("types.xls"), sheet = "logical_coercion",
      col_types = c("logical", "text"))
    Condition
      Warning:
      Expecting logical in A14 / R14C1: got 'cabbage'
      Warning:
      Expecting logical in A18 / R18C1: got a date

---

    Code
      df <- read_excel(test_sheet("types.xlsx"), sheet = "logical_coercion",
      col_types = c("logical", "text"))
    Condition
      Warning:
      Expecting logical in A14 / R14C1: got 'cabbage'
      Warning:
      Expecting logical in A18 / R18C1: got a date

# contaminated, explicit date is read as date

    Code
      df <- read_excel(test_sheet("types.xls"), sheet = "date_coercion", col_types = "date")
    Condition
      Warning:
      Expecting date in A4 / R4C1: got boolean
      Warning:
      Expecting date in A5 / R5C1: got 'cabbage'
      Warning:
      Coercing numeric to date in A6 / R6C1
      Warning:
      Coercing numeric to date in A7 / R7C1

---

    Code
      df <- read_excel(test_sheet("types.xlsx"), sheet = "date_coercion", col_types = "date")
    Condition
      Warning:
      Expecting date in A4 / R4C1: got boolean
      Warning:
      Expecting date in A5 / R5C1: got 'cabbage'
      Warning:
      Coercing numeric to date in A6 / R6C1
      Warning:
      Coercing numeric to date in A7 / R7C1

# contaminated, explicit numeric is read as numeric

    Code
      df <- read_excel(test_sheet("types.xls"), sheet = "numeric_coercion",
      col_types = "numeric")
    Condition
      Warning:
      Coercing text to numeric in A3 / R3C1: '72'
      Warning:
      Coercing boolean to numeric in A5 / R5C1
      Warning:
      Expecting numeric in A6 / R6C1: got a date
      Warning:
      Expecting numeric in A7 / R7C1: got 'cabbage'

---

    Code
      df <- read_excel(test_sheet("types.xlsx"), sheet = "numeric_coercion",
      col_types = "numeric")
    Condition
      Warning:
      Coercing text to numeric in A3 / R3C1: '72'
      Warning:
      Coercing boolean to numeric in A5 / R5C1
      Warning:
      Expecting numeric in A6 / R6C1: got a date
      Warning:
      Expecting numeric in A7 / R7C1: got 'cabbage'

# informative error when requesting non-existent sheet by name

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = "tulip")
    Condition
      Error:
      ! Sheet 'tulip' not found

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), range = "tulip!A1:A1")
    Condition
      Error:
      ! Sheet 'tulip' not found

# informative error when requesting non-existent sheet by position

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = 2)
    Condition
      Error:
      ! Can't retrieve sheet in position 2, only 1 sheet(s) found.

---

    Code
      read_excel(test_sheet("iris-excel-xls.xls"), sheet = 2)
    Condition
      Error:
      ! Can't retrieve sheet in position 2, only 1 sheet(s) found.

# invalid sheet values caught

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = 0)
    Condition
      Error:
      ! `sheet` must be positive

---

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), sheet = rep(1L, 2))
    Condition
      Error:
      ! `sheet` must have length 1

# double specification of sheet generates message and range wins

    Code
      double <- read_excel(test_sheet("sheet-xml-lookup.xlsx"), sheet = "Asia",
      range = "Oceania!A1:A1")
    Message
      Two values given for `sheet`. Using the `sheet` found in `range`:
      Oceania

# wrong length column names are rejected

    Code
      read_excel(test_sheet("iris-excel-xlsx.xlsx"), col_names = LETTERS[1:3])
    Condition
      Error:
      ! Sheet 1 has 5 columns (5 unskipped), but `col_names` has length 3.

---

    Code
      read_excel(test_sheet("iris-excel-xls.xls"), col_names = LETTERS[1:3])
    Condition
      Error:
      ! Sheet 1 has 5 columns (5 unskipped), but `col_names` has length 3.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example.R
\name{readxl_example}
\alias{readxl_example}
\title{Get path to readxl example}
\usage{
readxl_example(path = NULL)
}
\arguments{
\item{path}{Name of file. If \code{NULL}, the example files will be listed.}
}
\description{
readxl comes bundled with some example files in its \code{inst/extdata}
directory. This function make them easy to access.
}
\examples{
readxl_example()
readxl_example("datasets.xlsx")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/progress.R
\name{readxl_progress}
\alias{readxl_progress}
\title{Determine whether to show progress spinner}
\usage{
readxl_progress()
}
\description{
By default, readxl displays a progress spinner \strong{unless}
one of the following is \code{TRUE}:
\itemize{
\item The spinner is explicitly disabled by setting
\code{options(readxl.show_progress = FALSE)}.
\item The code is run in a non-interactive session (\code{interactive()} is \code{FALSE}).
\item The code is run by knitr / rmarkdown.
\item The code is run in an RStudio notebook chunk.
readxl uses the \href{https://cran.r-project.org/package=progress}{progress package} under-the-hood and
therefore is also sensitive to any options that it consults.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cell-specification.R
\name{cell-specification}
\alias{cell-specification}
\alias{cell_limits}
\alias{cell_rows}
\alias{cell_cols}
\alias{anchored}
\title{Specify cells for reading}
\description{
The \code{range} argument of \code{\link[=read_excel]{read_excel()}} provides many ways to limit the read
to a specific rectangle of cells. The simplest usage is to provide an
Excel-like cell range, such as \code{range = "D12:F15"} or
\code{range ="R1C12:R6C15"}. The cell rectangle can be specified in various other ways,
using helper functions. You can find more examples at the
\href{https://readxl.tidyverse.org/articles/sheet-geometry.html#range}{sheet geometry}
vignette. In all cases, cell range processing is handled by the
\link[cellranger:cellranger]{cellranger} package, where you can find full documentation for
the functions used in the examples below.
}
\examples{
path <- readxl_example("geometry.xls")
## Rows 1 and 2 are empty (as are rows 7 and higher)
## Column 1 aka "A" is empty (as are columns 5 of "E" and higher)

# By default, the populated data cells are "shrink-wrapped" into a
# minimal data frame
read_excel(path)

# Specific rectangle that is subset of populated cells, possibly improper
read_excel(path, range = "B3:D6")
read_excel(path, range = "C3:D5")

# Specific rectangle that forces inclusion of unpopulated cells
read_excel(path, range = "A3:D5")
read_excel(path, range = "A4:E5")
read_excel(path, range = "C5:E7")

# Anchor a rectangle of specified size at a particular cell
read_excel(path, range = anchored("C4", dim = c(3, 2)), col_names = FALSE)

# Specify only the rows
read_excel(path, range = cell_rows(3:5))
## is equivalent to
read_excel(path, range = cell_rows(c(3, 5)))

# Specify only the columns by column number or letter
read_excel(path, range = cell_cols("C:D"))
read_excel(path, range = cell_cols(2))

# Specify exactly one row or column bound
read_excel(path, range = cell_rows(c(5, NA)))
read_excel(path, range = cell_rows(c(NA, 4)))
read_excel(path, range = cell_cols(c("C", NA)))
read_excel(path, range = cell_cols(c(NA, 2)))

# General open rectangles
# upper left = C4, everything else unspecified
read_excel(path, range = cell_limits(c(4, 3), c(NA, NA)))
# upper right = D4, everything else unspecified
read_excel(path, range = cell_limits(c(4, NA), c(NA, 4)))

}
\seealso{
The \link[cellranger:cellranger]{cellranger} package has full documentation on cell
specification and offers additional functions for manipulating "A1:D10"
style spreadsheet ranges. Here are the most relevant:
\itemize{
\item \code{\link[cellranger:cell_limits]{cellranger::cell_limits()}}
\item \code{\link[cellranger:cell_rows]{cellranger::cell_rows()}}
\item \code{\link[cellranger:cell_cols]{cellranger::cell_cols()}}
\item \code{\link[cellranger:anchored]{cellranger::anchored()}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readxl-package.R
\docType{package}
\name{readxl-package}
\alias{readxl}
\alias{readxl-package}
\title{readxl: Read Excel Files}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Import excel files into R. Supports '.xls' via the embedded 'libxls' C library \url{https://github.com/libxls/libxls} and '.xlsx' via the embedded 'RapidXML' C++ library \url{https://rapidxml.sourceforge.net/}. Works on Windows, Mac and Linux without external dependencies.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://readxl.tidyverse.org}
  \item \url{https://github.com/tidyverse/readxl}
  \item Report bugs at \url{https://github.com/tidyverse/readxl/issues}
}

}
\author{
\strong{Maintainer}: Jennifer Bryan \email{jenny@posit.co} (\href{https://orcid.org/0000-0002-6983-2759}{ORCID})

Authors:
\itemize{
  \item Jennifer Bryan \email{jenny@posit.co} (\href{https://orcid.org/0000-0002-6983-2759}{ORCID})
  \item Hadley Wickham \email{hadley@posit.co} (\href{https://orcid.org/0000-0003-4757-117X}{ORCID})
}

Other contributors:
\itemize{
  \item Posit, PBC (Copyright holder of all R code and all C/C++ code without explicit copyright attribution) [copyright holder, funder]
  \item Marcin Kalicinski (Author of included RapidXML code) [contributor, copyright holder]
  \item Komarov Valery (Author of included libxls code) [contributor, copyright holder]
  \item Christophe Leitienne (Author of included libxls code) [contributor, copyright holder]
  \item Bob Colbert (Author of included libxls code) [contributor, copyright holder]
  \item David Hoerl (Author of included libxls code) [contributor, copyright holder]
  \item Evan Miller (Author of included libxls code) [contributor, copyright holder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_excel.R
\name{read_excel}
\alias{read_excel}
\alias{read_xls}
\alias{read_xlsx}
\title{Read xls and xlsx files}
\usage{
read_excel(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
)

read_xls(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
)

read_xlsx(
  path,
  sheet = NULL,
  range = NULL,
  col_names = TRUE,
  col_types = NULL,
  na = "",
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = min(1000, n_max),
  progress = readxl_progress(),
  .name_repair = "unique"
)
}
\arguments{
\item{path}{Path to the xls/xlsx file.}

\item{sheet}{Sheet to read. Either a string (the name of a sheet), or an
integer (the position of the sheet). Ignored if the sheet is specified via
\code{range}. If neither argument specifies the sheet, defaults to the first
sheet.}

\item{range}{A cell range to read from, as described in \link{cell-specification}.
Includes typical Excel ranges like "B3:D87", possibly including the sheet
name like "Budget!B2:G14", and more. Interpreted strictly, even if the
range forces the inclusion of leading or trailing empty rows or columns.
Takes precedence over \code{skip}, \code{n_max} and \code{sheet}.}

\item{col_names}{\code{TRUE} to use the first row as column names, \code{FALSE} to get
default names, or a character vector giving a name for each column. If user
provides \code{col_types} as a vector, \code{col_names} can have one entry per
column, i.e. have the same length as \code{col_types}, or one entry per
unskipped column.}

\item{col_types}{Either \code{NULL} to guess all from the spreadsheet or a
character vector containing one entry per column from these options:
"skip", "guess", "logical", "numeric", "date", "text" or "list". If exactly
one \code{col_type} is specified, it will be recycled. The content of a cell in
a skipped column is never read and that column will not appear in the data
frame output. A list cell loads a column as a list of length 1 vectors,
which are typed using the type guessing logic from \code{col_types = NULL}, but
on a cell-by-cell basis.}

\item{na}{Character vector of strings to interpret as missing values. By
default, readxl treats blank cells as missing data.}

\item{trim_ws}{Should leading and trailing whitespace be trimmed?}

\item{skip}{Minimum number of rows to skip before reading anything, be it
column names or data. Leading empty rows are automatically skipped, so this
is a lower bound. Ignored if \code{range} is given.}

\item{n_max}{Maximum number of data rows to read. Trailing empty rows are
automatically skipped, so this is an upper bound on the number of rows in
the returned tibble. Ignored if \code{range} is given.}

\item{guess_max}{Maximum number of data rows to use for guessing column
types.}

\item{progress}{Display a progress spinner? By default, the spinner appears
only in an interactive session, outside the context of knitting a document,
and when the call is likely to run for several seconds or more. See
\code{\link[=readxl_progress]{readxl_progress()}} for more details.}

\item{.name_repair}{Handling of column names. Passed along to
\code{\link[tibble:as_tibble]{tibble::as_tibble()}}. readxl's default is `.name_repair = "unique", which
ensures column names are not empty and are unique.}
}
\value{
A \link[tibble:tibble-package]{tibble}
}
\description{
Read xls and xlsx files

\code{read_excel()} calls \code{\link[=excel_format]{excel_format()}} to determine if \code{path} is xls or xlsx,
based on the file extension and the file itself, in that order. Use
\code{read_xls()} and \code{read_xlsx()} directly if you know better and want to
prevent such guessing.
}
\examples{
datasets <- readxl_example("datasets.xlsx")
read_excel(datasets)

# Specify sheet either by position or by name
read_excel(datasets, 2)
read_excel(datasets, "mtcars")

# Skip rows and use default column names
read_excel(datasets, skip = 10, col_names = FALSE)

# Recycle a single column type
read_excel(datasets, col_types = "text")

# Specify some col_types and guess others
read_excel(
  readxl_example("deaths.xlsx"),
  skip = 4, n_max = 10, col_names = TRUE,
  col_types = c("text", "text", "guess", "guess", "guess", "guess")
)

# Accomodate a column with disparate types via col_type = "list"
df <- read_excel(readxl_example("clippy.xlsx"), col_types = c("text", "list"))
df
df$value
sapply(df$value, class)

# Limit the number of data rows read
read_excel(datasets, n_max = 3)

# Read from an Excel range using A1 or R1C1 notation
read_excel(datasets, range = "C1:E7")
read_excel(datasets, range = "R1C2:R2C5")

# Specify the sheet as part of the range
read_excel(datasets, range = "mtcars!B1:D5")

# Read only specific rows or columns
read_excel(datasets, range = cell_rows(102:151), col_names = FALSE)
read_excel(datasets, range = cell_cols("B:D"))

# Get a preview of column names
names(read_excel(readxl_example("datasets.xlsx"), n_max = 0))

# exploit full .name_repair flexibility from tibble

# "universal" names are unique and syntactic
read_excel(
  readxl_example("deaths.xlsx"),
  range = "arts!A5:F15",
  .name_repair = "universal"
)

# specify name repair as a built-in function
read_excel(readxl_example("clippy.xlsx"), .name_repair = toupper)

# specify name repair as a custom function
my_custom_name_repair <- function(nms) tolower(gsub("[.]", "_", nms))
read_excel(
  readxl_example("datasets.xlsx"),
  .name_repair = my_custom_name_repair
)

# specify name repair as an anonymous function
read_excel(
  readxl_example("datasets.xlsx"),
  sheet = "chickwts",
  .name_repair = ~ substr(.x, start = 1, stop = 3)
)
}
\seealso{
\link{cell-specification} for more details on targetting cells with the
\code{range} argument
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/excel-sheets.R
\name{excel_sheets}
\alias{excel_sheets}
\title{List all sheets in an excel spreadsheet}
\usage{
excel_sheets(path)
}
\arguments{
\item{path}{Path to the xls/xlsx file.}
}
\description{
The list of sheet names is especially useful when you want to iterate over
all of the sheets in a workbook. The \href{https://readxl.tidyverse.org/articles/readxl-workflows.html}{readxl Workflows article}
provides several worked examples of this, showing how to combine readxl with
other packages in the tidyverse, such as purrr, or with base R functions like
\code{\link[=lapply]{lapply()}}.
}
\examples{
excel_sheets(readxl_example("datasets.xlsx"))
excel_sheets(readxl_example("datasets.xls"))

# To load all sheets in a workbook, use lapply()
path <- readxl_example("datasets.xls")
lapply(excel_sheets(path), read_excel, path = path)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/excel-format.R
\name{excel_format}
\alias{excel_format}
\alias{format_from_ext}
\alias{format_from_signature}
\title{Determine file format}
\usage{
excel_format(path, guess = TRUE)

format_from_ext(path)

format_from_signature(path)
}
\arguments{
\item{path}{Path to the xls/xlsx file.}

\item{guess}{Logical. If the file extension is absent or not recognized, this
controls whether we attempt to guess format based on the file signature or
"magic number".}
}
\value{
Character vector with values \code{"xlsx"}, \code{"xls"}, or \code{NA}.
}
\description{
Determine if files are xls or xlsx (or from the xlsx family).

\code{excel_format(guess = TRUE)} is used by \code{read_excel()} to
determine format. It draws on logic from two lower level functions:
\itemize{
\item \code{format_from_ext()} attempts to determine format from the file extension.
\item \code{format_from_signature()} consults the \href{https://en.wikipedia.org/wiki/List_of_file_signatures}{file signature} or "magic
number".
}

File extensions associated with xlsx vs. xls:
\itemize{
\item xlsx: \code{.xlsx}, \code{.xlsm}, \code{.xltx}, \code{.xltm}
\item xls: \code{.xls}
}

File signatures (in hexadecimal) for xlsx vs xls:
\itemize{
\item xlsx: First 4 bytes are \verb{50 4B 03 04}
\item xls: First 8 bytes are \verb{D0 CF 11 E0 A1 B1 1A E1}
}
}
\examples{
files <- c(
  "a.xlsx",
  "b.xls",
  "c.png",
  file.path(R.home("doc"), "html", "logo.jpg"),
  readxl_example("clippy.xlsx"),
  readxl_example("deaths.xls")
)
excel_format(files)
}
